/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: FixedMemoryPool.cc
   Note: Ĺס륯饹 ͥƥ֥᥽å

   Version
    0.020     1999/10/1  λ꡼С
    0.030     1999/10/

*/

#include <jni.h>

/* JAVAHǺincludeե */
#ifdef JTRON_JAVAH
#include <jp_gr_itron_jtron_attach_FixedMemoryPool.h>
#endif
#ifndef JTRON_JAVAH
#include <system_pkgs/jp_gr_itron_jtron_attach_FixedMemoryPool.h>
#endif

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JIL */
/* #include <jil_std.h> */
/* JILεǽŪɬפǤϤʤΤbstdlibɤ*/ 

/* JTRON饹 */
#include <jti_common.h>
#include <jti_attach_common.h>

/* Linuxƥ */
#ifdef LINUXDEV
#include <stdlib.h>
#include <itronstub_extern.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
#include <bstdlib.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif


/*
 *  Ĺס륢å饹Υͥƥ֥᥽åɷ
 */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_FixedMemoryPool_fixedmemorypool_1exist_1jtn
(JNIEnv *env, jobject thisObj, jint mpfid)
{
  ER err;

  T_RMPF rmpf;

#ifdef JTRON_DEBUG
  printf("> fixedmemorypool_existi_jtn() mpfid=%d\n",mpfid);
#endif

  // ꤵ줿IDΥ꥽뤫å롣
  err = ref_mpf(&rmpf,mpfid);

#ifdef JTRON_DEBUG
  printf("> fixedmemorypool_existi_jtn() err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_MPF);
  } 
}

JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_FixedMemoryPool_fixedmemorypool_1new_1jtn
(JNIEnv *env, jobject thisObj, jint mpfid, jobject obj_cmpf)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CMPF cmpf;

  // ǡѥåȤΥå
  if( obj_cmpf==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_CRE_MPF);
    return; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmpf);
  fid = env->GetFieldID(clazz,"mpfatr","I");
  cmpf.mpfatr = env->GetIntField(obj_cmpf,fid);
  fid = env->GetFieldID(clazz,"mpfcnt","I");
  cmpf.mpfcnt = env->GetIntField(obj_cmpf,fid);
  fid = env->GetFieldID(clazz,"blfsz","I");
  cmpf.blfsz = env->GetIntField(obj_cmpf,fid);

#ifdef JTRON_DEBUG
  printf("> fixedmemorypool_new_jtn(a):mpfid=%d\n",mpfid);
#endif

  /* ӥ */
  err = cre_mpf(mpfid,&cmpf); 

#ifdef JTRON_DEBUG
  printf("> fixedmemorypool_new_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_CRE_MPF);
  }
}

JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_FixedMemoryPool_fixedmemorypool_1newa_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_cmpf)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CMPF cmpf;

  // ǡѥåȤΥå
  if( obj_cmpf==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_CRE_MPF);
    return 0; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmpf);
  fid = env->GetFieldID(clazz,"mpfatr","I");
  cmpf.mpfatr = env->GetIntField(obj_cmpf,fid);
  fid = env->GetFieldID(clazz,"mpfcnt","I");
  cmpf.mpfcnt = env->GetIntField(obj_cmpf,fid);
  fid = env->GetFieldID(clazz,"blfsz","I");
  cmpf.blfsz = env->GetIntField(obj_cmpf,fid);

  /* ӥ */
  err = vcre_mpf(&cmpf); 

#ifdef JTRON_DEBUG
  printf("> fixedmemorypool_newa_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_VCRE_MPF);
  }

  return (jint)err;
}

JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_FixedMemoryPool_delete_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err = del_mpf(id);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_DEL_MPF);
    return;
  }
}

JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_FixedMemoryPool_referstatus_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_rmpf)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_RMPF rmpf; 
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> call referstatus_jtn():id=%d\n",id);
#endif


#ifdef JTRON_DEBUG
  printf("> ItronSystemCall ref_mpf(&rmpf,id) id=%d\n",id);
#endif
  /* ӥ */
  err = ref_mpf(&rmpf,id);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return ref_mpf(&rmpf,id)\n");
  printf("> rmpf.frbcnt=%d\n",rmpf.frbcnt);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_MPF);
    return;
  }

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rmpf);
  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rmpf,fid,rmpf.wtsk);
  fid = env->GetFieldID(clazz,"frbcnt","I");
  env->SetIntField(obj_rmpf,fid,rmpf.frbcnt);

#ifdef JTRON_DEBUG
  printf("> call return referstatus_jtn()\n");
#endif

}

JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_FixedMemoryPool_get_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_im, jint functype, jint tmout)
{
  jclass clazz;
  jfieldID fid; 
  ER err;
  void *vp;
  int id;
  int len;
  
  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> call get_jtn() id=%d\n",id);
  printf("> functype=%d\n",functype);
#endif

  if(functype == FUNCTYPE_NORMAL ) {

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall get_blf(&vp,id) id=%d\n",id);
#endif
    /* ӥ */
    err=get_blf(&vp,id);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return get_blf(&vp,id)\n");
  printf("> vp=%x\n",vp);
#endif
    if(err<0) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_GET_BLF);
      return;
    }
  }
  if(functype == FUNCTYPE_TIMEOUT ) {
    /* ӥ */
    err=tget_blf(&vp,id,tmout);
    if(err<0) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_TGET_BLF);
      return;
    }
  }
  if(functype == FUNCTYPE_POLL ) {
    /* ӥ */
    err=pget_blf(&vp,id);
    if(err<0) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_PGET_BLF);
      return;
    }
  }

#ifdef JTRON_DEBUG
  printf("> get_jtn():err=%d\n",err);
#endif

  /* ΰξItronMemory˥å */
  setAddr_jtc(env,obj_im,vp);

  /* ΰĹItronMemory˥å */
  clazz = env->GetObjectClass(thisObj);
  fid = env->GetFieldID(clazz,"blockSize","I");
  len = env->GetIntField(thisObj,fid);
  setMemLen_jtc(env,obj_im,len);

  /* ΰ西פΥå */
  setMemType_jtc(env,obj_im,MTYPE_MEMPOOL);

#ifdef JTRON_DEBUG
  printf("> call return get_jtn()\n");
#endif

}

#ifdef __cplusplus
}
#endif



