/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: MessageBuffer.cc
   Note: MessageBuffer饹Υͥƥ֥᥽åɷ

   Version
    0.020     1999/10/1  λ꡼С
    0.030     1999/10/

*/

#include <jni.h>

/* JAVAHǺincludeե */
#ifdef JTRON_JAVAH
#include <jp_gr_itron_jtron_attach_MessageBuffer.h>
#endif
#ifndef JTRON_JAVAH
#include <system_pkgs/jp_gr_itron_jtron_attach_MessageBuffer.h>
#endif

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JIL */
/* #include <jil_std.h> */
/* JILεǽŪɬפǤϤʤΤbstdlibɤ*/ 

/* JTRON饹 */
#include <jti_common.h>
#include <jti_attach_common.h>

/* Linuxƥ */
#ifdef LINUXDEV
#include <stdlib.h>
#include <itronstub_extern.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
#include <bstdlib.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  åХåեå饹Υͥƥ֥᥽åɷ
 */

/* private native int messagebuffer_exist_jtn(int mbfId) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_MessageBuffer_messagebuffer_1exist_1jtn
(JNIEnv *env, jobject thisObj, jint mbfid)
{
  ER err;

  T_RMBF rmbf;

#ifdef JTRON_DEBUG
  printf("> messagebuffer_exist_jtn(a):mbfid=%d\n",mbfid);
#endif

  // ꤵ줿IDΥ꥽뤫å롣
  err = ref_mbf(&rmbf,mbfid);

#ifdef JTRON_DEBUG
  printf("> messagebuffer_exist_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_MBF);
  }

  return (jint)err;
}


/* private native void messagebuffer_new_jtn(int mbfid,T_CMBF cmbf) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_MessageBuffer_messagebuffer_1new_1jtn
(JNIEnv *env, jobject thisObj, jint mbfid, jobject obj_cmbf)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CMBF cmbf;

#ifdef JTRON_DEBUG
  printf("> call messagebuffer_new_jtn(mbfid,cmbf) mbfid=%d\n",mbfid);
#endif

  // ǡѥåȤΥå
  if( obj_cmbf==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_CRE_MBF);
    return; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmbf);
  fid = env->GetFieldID(clazz,"mbfatr","I");
  cmbf.mbfatr = env->GetIntField(obj_cmbf,fid);
  fid = env->GetFieldID(clazz,"bufsz","I");
  cmbf.bufsz = env->GetIntField(obj_cmbf,fid);
  fid = env->GetFieldID(clazz,"maxmsz","I");
  cmbf.maxmsz = env->GetIntField(obj_cmbf,fid);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall cre_mbf(mbfid,&cmbf) mbfid=%d\n",mbfid);
  printf("> cmbf.mbfatr=%d\n",cmbf.mbfatr);
  printf("> cmbf.bufsz=%d\n",cmbf.bufsz);
  printf("> cmbf.maxmsz=%d\n",cmbf.maxmsz);
#endif
  /* ӥ */
  err = cre_mbf(mbfid,&cmbf); 
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return cre_mbf(mbfid,&cmbf)\n");
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_CRE_MBF);
  }

#ifdef JTRON_DEBUG
  printf("> call return messagebuffer_new_jtn(mbfid,cmbf)\n");
#endif

}

/* private native int messagebuffer_newa_jtn(T_CMBF cmbf) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_MessageBuffer_messagebuffer_1newa_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_cmbf)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CMBF cmbf;

  // ǡѥåȤΥå
  if( obj_cmbf==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_VCRE_MBF);
    return 0; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmbf);
  fid = env->GetFieldID(clazz,"mbfatr","I");
  cmbf.mbfatr = env->GetIntField(obj_cmbf,fid);
  fid = env->GetFieldID(clazz,"bufsz","I");
  cmbf.bufsz = env->GetIntField(obj_cmbf,fid);
  fid = env->GetFieldID(clazz,"maxmsz","I");
  cmbf.maxmsz = env->GetIntField(obj_cmbf,fid);


  /* ӥ */
  err = vcre_mbf(&cmbf); 

#ifdef JTRON_DEBUG
  printf("> messagebuffer_new_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_VCRE_MBF);
  }

  return (jint)err;

}

/* private native void delete_jtn()  */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_MessageBuffer_delete_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err=del_mbf(id);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_DEL_MBF);
  }
}

/* private native void send_jtn(ItronMemory data) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_MessageBuffer_send_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_im, jint functype, jint tmout)
{
  ER err;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;
  int id;
  int msgsz;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

  /* ItronMemoryĹ롣*/
  msgsz=getMemLen_jtc(env,obj_im);

#ifdef JTRON_DEBUG
  printf("> send_jtn(a):id=%d\n",id);
  printf("> send_jtn(a):functype=%d\n",functype);
#endif

  if( functype == FUNCTYPE_NORMAL ) {
    /* ӥ */
    err=snd_mbf(id,vp,msgsz);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_SND_MBF);
    }
  }

  if( functype == FUNCTYPE_TIMEOUT ) {
    /* ӥ */
    err=tsnd_mbf(id,vp,msgsz,tmout);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_TSND_MBF);
    }
  }

  if( functype == FUNCTYPE_POLL ) {
    /* ӥ */
    err=psnd_mbf(id,vp,msgsz);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_PSND_MBF);
    }
  }

#ifdef JTRON_DEBUG
  printf("> send_jtn(a):err=%d\n",err);
#endif
  
}

/* private native void receivewithmemory_jtn(ItronMemory data) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_MessageBuffer_receivewithmemory_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_im, jint functype, jint tmout)
{
  T_RMBF rmbf;
  ER err;
  INT msgsz;
  VP msg;
  jint ad_i;
  
  jclass clazz;
  jfieldID fid;
  int id;

#ifdef JTRON_DEBUG
  printf("> call receivewithmemory_jtn(data,functype,tmout)\n");
  printf("> functype=%d\n",functype);
  printf("> tmout=%d\n",tmout);
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);
  
  /* ItronMemoryĹ롣*/
  msgsz = getMemLen_jtc(env,obj_im);

  /* ΰ襵η */
  err=ref_mbf(&rmbf,id);
  if(err<0) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_MBF);
    return;
  }

  /* withǤrecieveϴˤΰȤ*/
  /* ΰ褬­ʤ,顼Ȥ롣*/
  /*  ¾ڼ¸ѥƥȤԶȯ  
         if(msgsz <= rmbf.msgsz) ǤƱ礭Ǥ⥨顼ˤʤ롣
                  <=  < ѹ */
  if(msgsz < rmbf.msgsz) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_RCV_MBF);
    return; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  msg=getAddr_jtc(env,obj_im);

  if( functype == FUNCTYPE_NORMAL ) {

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall rcv_mbf(msg,&msgsz,id) id=%d\n",id);
#endif
    /* ӥ */
    err=rcv_mbf(msg,&msgsz,id);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return rcv_mbf(msg,&msgsz,id)");
  printf("> msg=%x",msg);
  printf("> msgsz=%d",msgsz);
#endif  

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_RCV_MBF);
    }
  }

  /* 
     ʲItronMemoryؤΰƤѤ롣
     ,ItronMemoryΥ,ĹȤꤹϤʤ
   */

  if( functype == FUNCTYPE_TIMEOUT ) {
    /* ӥ */
    err=trcv_mbf(msg,&msgsz,id,tmout);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_TRCV_MBF);
    }
  }

  if( functype == FUNCTYPE_POLL ) {
    /* ӥ */
    err=prcv_mbf(msg,&msgsz,id);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_PRCV_MBF);
    }
  }

#ifdef JTRON_DEBUG
  printf("> call return receivewithmemory_jtn(data,functype,tmout)\n");
#endif

}

/* private native void referstatus(T_RMBF rmbf) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_MessageBuffer_referstatus_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_rmbf)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_RMBF rmbf; 
  int id;

#ifdef JTRON_DEBUG
  printf("> call referstatus_jtn(rmbf)\n");
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall ref_mbf(&rmbf,id) id=%d\n",id);
#endif
  /* ӥ */
  err = ref_mbf(&rmbf,id);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return ref_mbf(&rmbf,id)\n");
  printf("> rmbf.wtsk=%d\n",rmbf.wtsk);
  printf("> rmbf.stsk=%d\n",rmbf.stsk);
  printf("> rmbf.msgsz=%d\n",rmbf.msgsz);
  printf("> rmbf.frbufsz=%d\n",rmbf.frbufsz);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_MBF);
    return;
  }

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rmbf);
  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rmbf,fid,rmbf.wtsk);
  fid = env->GetFieldID(clazz,"stsk","I");
  env->SetIntField(obj_rmbf,fid,rmbf.stsk);
  fid = env->GetFieldID(clazz,"msgsz","I");
  env->SetIntField(obj_rmbf,fid,rmbf.msgsz);
  fid = env->GetFieldID(clazz,"frbufsz","I");
  env->SetIntField(obj_rmbf,fid,rmbf.frbufsz);

#ifdef JTRON_DEBUG
  printf("> call return referstatus_jtn(rmbf)\n");
#endif

}

#ifdef __cplusplus
}
#endif
