/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: Port.cc
   Note: Port饹Υͥƥ֥᥽åɷ

   Version
    0.020     1999/10/1  λ꡼С
    0.030     1999/10/

*/

#include <jni.h>

/* JAVAHǺincludeե */
#ifdef JTRON_JAVAH
#include <jp_gr_itron_jtron_attach_Port.h>
#endif
#ifndef JTRON_JAVAH
#include <system_pkgs/jp_gr_itron_jtron_attach_Port.h>
#endif

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JIL */
/* #include <jil_std.h> */
/* JILεǽŪɬפǤϤʤΤbstdlibɤ*/ 

/* JTRON饹 */
#include <jti_common.h>
#include <jti_attach_common.h>

/* Linuxƥ */
#ifdef LINUXDEV
#include <stdlib.h>
#include <itronstub_extern.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
#include <bstdlib.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ݡȥå饹Υͥƥ֥᥽åɷ
 */
/* private native int port_exist_jtn(int portId)  */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_Port_port_1exist_1jtn
(JNIEnv *env, jobject thisObj, jint portid)
{
  ER err;
  T_RPOR rpor;
  jclass clazz;
  jfieldID fid;

#ifdef JTRON_DEBUG
  printf("> port_exist_jtn(a):portid=%d\n",portid);
#endif

  /* ӥ */
  err = ref_por(&rpor,portid);

#ifdef JTRON_DEBUG
  printf("> port_exist_jtn(a):err=%d\n",err);
#endif

  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_POR);
  }

  /* BrightV˰¸  ͤǤmax[cr]sizerporʤ */
  clazz = env->GetObjectClass(thisObj);
  fid = env->GetFieldID(clazz,"MaxCSize","I");
  env->SetIntField(thisObj,fid,rpor.maxcmsz);
  fid = env->GetFieldID(clazz,"MaxRSize","I");
  env->SetIntField(thisObj,fid,rpor.maxrmsz);

  return (jint)err;
}

/* private native void port_new_jtn(int portid,T_CPOR cpor) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Port_port_1new_1jtn
(JNIEnv *env, jobject thisObj, jint portid, jobject obj_cpor)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CPOR cpor;

#ifdef JTRON_DEBUG
  printf("> call port_new_jtn(int portid,T_CPOR cpor) portid=%d\n",portid);
  printf("> cpor.poratr=%d\n",cpor.poratr);
  printf("> cpor.maxcmsz=%d\n",cpor.maxcmsz);
  printf("> cpor.maxrmsz=%d\n",cpor.maxrmsz);
#endif

  // ǡѥåȤΥå
  if( obj_cpor==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_CRE_POR);
    return; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cpor);
  fid = env->GetFieldID(clazz,"poratr","I");
  cpor.poratr = env->GetIntField(obj_cpor,fid); 
  fid = env->GetFieldID(clazz,"maxcmsz","I");
  cpor.maxcmsz = env->GetIntField(obj_cpor,fid);
  fid = env->GetFieldID(clazz,"maxrmsz","I");
  cpor.maxrmsz = env->GetIntField(obj_cpor,fid);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall cre_por(portid,&cpor) portid=%d\n",portid);
#endif
  /* ӥ */
  err = cre_por(portid,&cpor);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return cre_por(portid,&cpor)\n");
  printf("> err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_CRE_POR);
  }

#ifdef JTRON_DEBUG
  printf("> call port_new_jtn(int portid,T_CPOR cpor) portid=%d\n",portid);
#endif

}

/* private native int port_newa_jtn(T_CPOR cpor)  */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_Port_port_1newa_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_cpor)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CPOR cpor;
  
  // ǡѥåȤΥå
  if( obj_cpor==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_VCRE_POR);
    return 0; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cpor);
  fid = env->GetFieldID(clazz,"poratr","I");
  cpor.poratr = env->GetIntField(obj_cpor,fid); 
  fid = env->GetFieldID(clazz,"maxcmsz","I");
  cpor.maxcmsz = env->GetIntField(obj_cpor,fid);
  fid = env->GetFieldID(clazz,"maxrmsz","I");
  cpor.maxrmsz = env->GetIntField(obj_cpor,fid);

  /* ӥ */
  err = vcre_por(&cpor);

#ifdef JTRON_DEBUG
  printf("> port_newa_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_VCRE_POR);
  }

  return (jint)err;

}

/*  private native void delete_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Port_delete_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err=del_por(id);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_DEL_POR);
  }
}

/* private native void call_jtn(ItronMemory mem,ItronMemory outmem,int calptn,int csize)  */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Port_call_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_im, jobject obj_imo, jint calptn, jint csize,jint functype,jint tmout)
{  
  ER err;
  jint ad_i;
  VP vp;
  char *ccp,*rcp;
  VP rmsg;

  jclass clazz;
  jfieldID fid;
  INT rsize;
  INT maxcsize;
  INT maxrsize;
  int id;
  int len;
  int i;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /*
    åϤ&뤿ΰ롣
    Ĺ,åĹ롣
    ͳ,ITRON4.0 P.200
      ץꥱϴԤåΥ˴ؤ餺
      msgκĹʬΰݤ٤,Ȥ뤫顣
   */
  clazz = env->GetObjectClass(thisObj);
  fid = env->GetFieldID(clazz,"MaxCSize","I");
  maxcsize = env->GetIntField(thisObj,fid); 
  fid = env->GetFieldID(clazz,"MaxRSize","I");
  maxrsize = env->GetIntField(thisObj,fid); 
  if(maxrsize > maxcsize) {
    rsize=maxrsize;
  } else {
    rsize=maxcsize;
  }
  vp=(VP)malloc(rsize);

#ifdef JTRON_DEBUG
  printf("> call_jtn(a):csize=%d\n",csize);
  printf("> call_jtn(a):rsize=%d\n",rsize);
#endif

  /* åĹꤷcsizeۤȥ顼
     ӥƤӽФmemcpyΤȼ顼Ƚ */
  if(csize > rsize) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_CAL_POR);
    return;
  }

  /* å򥻥å */
  ccp=(char *)getAddr_jtc(env,obj_im);
  memcpy(vp,ccp,csize);

#ifdef JTRON_DEBUG
  printf("> call_jtn(a):functype=%d\n",functype);
#endif

  if( functype == FUNCTYPE_NORMAL ) { 
    /* ӥ */
    err=cal_por(vp,&rsize,id,calptn,csize);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_CAL_POR);
      return;
    }
  }
  if( functype == FUNCTYPE_TIMEOUT ) {
    /* ӥ */
    err=tcal_por(vp,&rsize,id,calptn,csize,tmout);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_TCAL_POR);
      return;
    }
  }
  if( functype == FUNCTYPE_POLL ) { 
    /* ӥ */
    err=pcal_por(vp,&rsize,id,calptn,csize);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_PCAL_POR);
      return;
    }
  }

#ifdef JTRON_DEBUG
  printf("> call_jtn(a):err=%d\n",err);
#endif

  /* åƱƤӽФåƱɥ쥹äƤ롣 
     ̤ΰ˰ܤ,ΰбItronMemory
     롣*/

  /* ֤ä褿å̤ΰذܤ */
  rmsg = (VP)malloc(rsize);
  memcpy(rmsg,vp,rsize);
  free(vp);

  /* ItronMemoryξ󥻥å */
  setAddr_jtc(env,obj_imo,(void *)rmsg);
  setMemLen_jtc(env,obj_imo,rsize);
  setMemType_jtc(env,obj_imo,MTYPE_ALLOC);
}

/* private native void accept_jtn(int acpptn,Rendezvous rdv) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Port_accept_1jtn
(JNIEnv *env, jobject thisObj, jint acpptn, jobject obj_rdv, jint functype, jint tmout)
{
  ER err;
  jint ad_i;
  VP vp;
  VP msg;
  char *cp,*cp1;
  
  jclass clazz;
  jfieldID fid;
  INT rsize;
  RNO rdvno;
  INT csize;
  INT maxcsize;

  int i;
  int id;

#ifdef JTRON_DEBUG
  printf("> call accept_jtn(data,functype,tmout)\n");
  printf("> functype=%d\n",functype);
  printf("> tmout=%d\n",tmout);
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* 
     åդΰݤ롣
        ƤӽФåĹݡ
     */
  clazz = env->GetObjectClass(thisObj);
  fid = env->GetFieldID(clazz,"MaxCSize","I");
  maxcsize = env->GetIntField(thisObj,fid); 
  vp=(VP *)malloc(maxcsize);

  if( functype == FUNCTYPE_NORMAL ) { 

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall acp_por(&rdvno,vp,&csize,id,acpptn) id=%d\n",id);
  printf("> acpptn=%d\n",acpptn);
#endif
    /* ӥ */
    err=acp_por(&rdvno,vp,&csize,id,acpptn);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return acp_por(&rdvno,vp,&csize,id,acpptn)\n");
  printf("> rdvno=%d\n",rdvno);
  printf("> vp=%x\n",vp);
  printf("> csize=%d\n",csize);
#endif

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_ACP_POR);
      return;
    }
  }
  if( functype == FUNCTYPE_TIMEOUT ) {
    /* ӥ */
    err=tacp_por(&rdvno,vp,&csize,id,acpptn,tmout);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_TACP_POR);
    }
  }
  if( functype == FUNCTYPE_POLL ) { 
    /* ӥ */
    err=pacp_por(&rdvno,vp,&csize,id,acpptn);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_PACP_POR);
    }
  }

  /* å֤ΰ,˰ư롣*/
  msg=(void *)malloc(csize);
  memcpy(msg,vp,csize);
  free(vp);

  /* åΰǥ(ItronMemoryΥ֥饹)˥å*/
  setAddr_jtc(env,obj_rdv,msg);
  setMemLen_jtc(env,obj_rdv,csize);
  setMemType_jtc(env,obj_rdv,MTYPE_ALLOC);

  /* ǥֹ򥻥å */
  clazz = env->GetObjectClass(obj_rdv);
  fid = env->GetFieldID(clazz,"No","I");
  env->SetIntField(obj_rdv,fid,rdvno); 

#ifdef JTRON_DEBUG
  printf("> call return accept_jtn(data,functype,tmout)\n");
#endif

}

/* private native void forward_jtn(int calptn,Rendezvous data)  */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Port_forward_1jtn
(JNIEnv *env, jobject thisObj, jint calptn, jobject obj_rdv)
{
  ER err;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;
  int id;
  int rdvno;
  int csize;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* ǥ(ItronMemory)γϥɥ쥹롣*/
  vp=(void *)getAddr_jtc(env,obj_rdv);
  csize =  getMemLen_jtc(env,obj_rdv);
  /* ֹ롣*/
  clazz = env->GetObjectClass(obj_rdv);
  fid = env->GetFieldID(clazz,"No","I");
  rdvno = env->GetIntField(obj_rdv,fid); 
  
#ifdef JTRON_DEBUG
  printf("> forward_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err=fwd_por(id,calptn,rdvno,vp,csize);
  
#ifdef JTRON_DEBUG
  printf("> forward_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_FWD_POR);
  }

}

/* private native void referstatus_jtn(T_RPOR rpor) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Port_referstatus_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_rpor)
{
  ER err;
  int id;
  jclass clazz;
  jfieldID fid;
  T_RPOR rpor;

#ifdef JTRON_DEBUG
  printf("> call referstatus_jtn(rpor)\n");
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall ref_por(&rpor,id) id=%d\n",id);
#endif
  /* ӥ */
  err = ref_por(&rpor,id);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return ref_por(&rpor,id)\n");
  printf("> rpor.wtsk=%d\n",rpor.wtsk);
  printf("> rpor.atsk=%d\n",rpor.atsk);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_POR);
    return;
  }

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rpor);
  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rpor,fid,rpor.wtsk);
  fid = env->GetFieldID(clazz,"atsk","I");
  env->SetIntField(obj_rpor,fid,rpor.atsk);
  
#ifdef JTRON_DEBUG
  printf("> call return referstatus_jtn(rpor)\n");
#endif

}

#ifdef __cplusplus
}
#endif
