/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: Semaphore.cc
   Note: Semaphore饹Υͥƥ֥᥽åɷ

   Version
    0.020     1999/10/1  λ꡼С
    0.030     1999/10/

*/

#include <jni.h>

/* JAVAHǺincludeե */
#ifdef JTRON_JAVAH
#include <jp_gr_itron_jtron_attach_Semaphore.h>
#endif
#ifndef JTRON_JAVAH
#include <system_pkgs/jp_gr_itron_jtron_attach_Semaphore.h>
#endif

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JIL */
/* #include <jil_std.h> */
/* JILεǽŪɬפǤϤʤΤbstdlibɤ*/ 

/* JTRON饹 */
#include <jti_common.h>
#include <jti_attach_common.h>

/* Linuxƥ */
#ifdef LINUXDEV
#include <itronstub_extern.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
#include <bstdlib.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ޥեå饹Υͥƥ֥᥽åɷ
 */

/* private native int semaphore_exist_jtn(int semId) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_Semaphore_semaphore_1exist_1jtn
(JNIEnv *env, jobject thisObj, jint semid)
{

  ER err;

  T_RSEM rsem;

#ifdef JTRON_DEBUG
  printf("> call semaphore_exist_jtn(int semid) semid=%d\n",semid);
#endif

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall ref_sem(&rsem,semid) semid=%d\n",semid);
#endif
  // ꤵ줿IDΥ꥽뤫å롣
  err = ref_sem(&rsem,semid);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return ref_sem(&rsem,semid)\n");
  printf("> rsem.wtsk=%d\n",rsem.wtsk);
  printf("> rsem.semcnt=%d\n",rsem.semcnt);
  printf("> err=%d\n",err);
#endif


  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_SEM);
  }

#ifdef JTRON_DEBUG
  printf("> call semaphore_exist_jtn(int semid)\n");
#endif

  return (jint)err;

}

/* private native void semaphore_new_jtn(int semid,T_CSEM csem) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Semaphore_semaphore_1new_1jtn
(JNIEnv *env, jobject thisObj, jint semid, jobject obj_csem)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CSEM csem;

  // ǡѥåȤΥå
  if( obj_csem==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_CRE_SEM);
    return; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_csem);
  fid = env->GetFieldID(clazz,"sematr","I");
  csem.sematr = env->GetIntField(obj_csem,fid);
  
  fid = env->GetFieldID(clazz,"isemcnt","I");
  csem.isemcnt = env->GetIntField(obj_csem,fid);

  fid = env->GetFieldID(clazz,"maxsem","I");
  csem.maxsem = env->GetIntField(obj_csem,fid);

#ifdef JTRON_DEBUG
  printf("> semaphore_new_jtn(a):semid=%d\n",semid);
  printf("> semaphore_new_jtn(a):csem.sematr=%d\n",csem.sematr);
  printf("> semaphore_new_jtn(a):csem.isemcnt=%d\n",csem.isemcnt);
  printf("> semaphore_new_jtn(a):csem.maxsem=%d\n",csem.maxsem);
#endif

  /* ӥ */
  err = cre_sem(semid,&csem);

#ifdef JTRON_DEBUG
  printf("> semaphore_new_jtn(a):err=%d\n",err);
#endif

  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_CRE_SEM);
  }

}

/* private native int semaphore_newa_jtn(T_CSEM csem) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_Semaphore_semaphore_1newa_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_csem)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CSEM csem;

  // ǡѥåȤΥå
  if( obj_csem==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_VCRE_SEM);
    return 0; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_csem);
  fid = env->GetFieldID(clazz,"sematr","I");
  csem.sematr = env->GetIntField(obj_csem,fid);
  
  fid = env->GetFieldID(clazz,"isemcnt","I");
  csem.isemcnt = env->GetIntField(obj_csem,fid);

  fid = env->GetFieldID(clazz,"maxsem","I");
  csem.maxsem = env->GetIntField(obj_csem,fid);

#ifdef JTRON_DEBUG
  printf("> semaphore_newa_jtn(a):csem.sematr=%d\n",csem.sematr);
  printf("> semaphore_newa_jtn(a):csem.isemcnt=%d\n",csem.isemcnt);
  printf("> semaphore_newa_jtn(a):csem.maxsem=%d\n",csem.maxsem);
#endif

  /* ӥ */
  err = vcre_sem(&csem);

#ifdef JTRON_DEBUG
  printf("> semaphore_newa_jtn(a):err=%d\n",err);
#endif

  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_VCRE_SEM);
  } 

  return (jint)err;
}

/* private native void delete_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Semaphore_delete_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> delete(a):id=%d\n",id);
#endif

  /* ӥ */
  err = del_sem(id);

#ifdef JTRON_DEBUG
  printf("> delete(a):err=%d\n",err);
#endif
  
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_DEL_SEM);
  }

}

/* private native void signal_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Semaphore_signal_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> signal(a):id=%d\n",id);
#endif

  /* ӥ */
  err = sig_sem(id);

#ifdef JTRON_DEBUG
  printf("> signal(a):err=%d\n",err);
#endif
  
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_SIG_SEM);
  }

}

/* private native void waitsemaphore_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Semaphore_waitsemaphore_1jtn__
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

#ifdef JTRON_DEBUG
  printf("> call waitsemaphore_jtn()\n");
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall wai_sem(id) id=%d\n",id);
#endif
  /* ӥ */
  err = wai_sem(id);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return wai_sem(id)\n");
  printf("> err=%d\n",err);
#endif

  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_WAI_SEM);
  }

#ifdef JTRON_DEBUG
  printf("> call return waitsemaphore_jtn()\n");
#endif

}

/* private native void waitsemaphore_jtn(int tmout) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Semaphore_waitsemaphore_1jtn__I
(JNIEnv *env, jobject thisObj, jint tmout)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> waitsemaphore_jtn(int tmout)(a):id=%d\n",id);
  printf("> waitsemaphore_jtn(int tmout)(a):tmout=%d\n",tmout);
#endif

  /* ӥ */
  err = twai_sem(id,tmout);

#ifdef JTRON_DEBUG
  printf("> waitsemaphore_jtn(int tmout)(a):err=%d\n",err);
#endif

  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_TWAI_SEM);
  }

}

/* private native void poll_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Semaphore_poll_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> poll_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err = preq_sem(id);

#ifdef JTRON_DEBUG
  printf("> poll_jtn(a):err=%d\n",err);
#endif

  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_PREQ_SEM);
  }

}

/* private native void referstatus_jtn(T_RSEM rsem) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Semaphore_referstatus_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_rsem)
{
  jclass clazz;
  jfieldID fid;

  int id;
  ER err;
  T_RSEM rsem; 

#ifdef JTRON_DEBUG
  printf("> call referstatus_jtn(rsem)\n");
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall ref_sem(&rsem,id) id=%d\n",id);
#endif
  /* ӥ */
  err = ref_sem(&rsem,id);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return ref_sem(&rsem,id)\n");
  printf("> rsem.wtsk=%d\n",rsem.wtsk);
  printf("> rsem.semcnt=%d\n",rsem.semcnt);
  printf("> err=%d\n",err);
#endif

  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_SEM);
    return;
  }

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rsem);

  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rsem,fid,rsem.wtsk);

  fid = env->GetFieldID(clazz,"semcnt","I");
  env->SetIntField(obj_rsem,fid,rsem.semcnt);

#ifdef JTRON_DEBUG
  printf("> call return referstatus_jtn(rsem)\n");
#endif

}

#ifdef __cplusplus
}
#endif
