/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*	File name: jti_debug.h
	Note: JTRON 2.0 Shared Object Interface ITRON API
	      (Debug print)
    	Date: 1999/9/13
	Last update: 2000/1/5
*/
#ifndef _JTI_DEBUG_H_
#define _JTI_DEBUG_H_

#ifdef __cplusplus
extern "C" {
#endif

/* Debug print */
#ifdef JTRON_DEBUG
#define TRACE_FUNC(a)      printf("Enter: %s\n",a)
#define DPRINT(fmt)        printf(fmt)
#define DPRINT1(fmt,a)     printf(fmt,a)
#define DPRINT2(fmt,a,b)   printf(fmt,a,b)
#define DPRINT3(fmt,a,b,c) printf(fmt,a,b,c)
#define DPRINT4(fmt,a,b,c,d) printf(fmt,a,b,c,d)
#else
#define TRACE_FUNC(a)
#define DPRINT(fmt)
#define DPRINT1(fmt,a)
#define DPRINT2(fmt,a,b)
#define DPRINT3(fmt,a,b,c)
#define DPRINT4(fmt,a,b,c,d)
#endif
#ifdef __cplusplus
}
#endif
#endif  /* _JTI_DEBUG_H_ */
