/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: JtiDataStreamPlainImpl.cc
   Note: JtiDataStreamPlainImpl饹Υͥƥ֥᥽åɷ

   Version
    0.020     1999/10/1  λ()꡼С
    0.030     1999/10/
*/

#include <jni.h>

/* JAVAHǺincludeե */
#ifdef JTRON_JAVAH
#include <jp_gr_itron_jtron_stream_JtiDataStreamPlainImpl.h>
#endif
#ifndef JTRON_JAVAH
#include <system_pkgs/jp_gr_itron_jtron_stream_JtiDataStreamPlainImpl.h>
#endif

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JTRON饹 */
#include <jti_common.h>
#ifndef LINUXDEV
#include <jti_stream_common.h>
#endif

/* Linuxƥ */
#ifdef LINUXDEV
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <streamstub.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
#include <bstdlib.h>
#include <bstring.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_stream_JtiDataStreamPlainImpl_conststream
(JNIEnv *env, jobject thisObj, jint stmid)
{
  int rv;

#ifdef JTRON_DEBUG
  printf("> call conststream(a):stmid=%d\n",stmid);
#endif

#ifdef JTRON_DEBUG
  printf("> Call jti_java_stm_open(stmid)\n");
#endif
  rv=jti_java_stm_open(stmid);
#ifdef JTRON_DEBUG
  printf("> Call Return jti_java_stm_open(stmid)\n");
#endif


#ifdef JTRON_DEBUG
  printf("> call return conststream(a):rv=%d\n",rv);
#endif

  return rv;
  
}

JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_stream_JtiDataStreamPlainImpl_close_1jtn
(JNIEnv *env, jobject thisObj, jint stmid, jint type)
{
  int rv=-1;

#ifdef JTRON_DEBUG
  printf("> call close_jtn(a):stmid=%d type=%d\n",stmid,type);
#endif
  
  if( type==0 ) {  // ϥȥ꡼Υ 
#ifdef JTRON_DEBUG
  printf("> close_jtn(a) inclose\n");
#endif
    rv=jti_java_stm_inclose(stmid);
#ifdef JTRON_DEBUG
  printf("> close_jtn(a) rv=%d\n",rv);
#endif
  } else {        // ϥȥ꡼Υ
#ifdef JTRON_DEBUG
  printf("> close_jtn(a) outclose\n");
#endif
    rv=jti_java_stm_outclose(stmid);
#ifdef JTRON_DEBUG
  printf("> close_jtn(a) rv=%d\n",rv);
#endif
  }

#ifdef LINUXDEV
  /* LinuxǤԤ֤ʤ*/
  /* PMCΥ饤֥Υ꤬? */
  /*  rv=0;  */
#endif

  /* PMCΥ饤֥ΥE_OBJȯ롣 */
  if( rv == E_OBJ ) {
    rv=0;
  }

  return rv;

}

#ifdef __cplusplus
}
#endif
