/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: jti_errno.h
   Note: JTRON 2.0 ITRON API
         顼ɤ
   Date: 1999/8/31
   Last update: 1999/9/29
*/
#ifndef _JTI_ERRNO_H_
#define _JTI_ERRNO_H_

#ifdef __cplusplus
extern "C" {
#endif

/*
   顼ޥ
*/
#define JTI_MAINERCD(ercd) (~(ercd & 0377))     /* ᥤ󥨥顼 */
#define JTI_SUBERCD(ercd)  (~(ercd>>8 & 0377))  /* ֥顼   */
#define JTI_IMPLERCD(ercd) (ercd>>16)           /* ¸顼   */

/*
   顼ޥ
*/
#define JTI_SET_MAINERCD(ercd)      (~ercd)
#define JTI_SET_SUBERCD(ercd)       ((~ercd)<<8)
#define JTI_SET_IMPLERCD(ercd)      (ercd<<16)

/* 3Ʊ˥å */
#define JTI_SET_ERCD(main,sub,impl) ( (impl<<16) | (~sub)<<8  | ~main )

/*
   ᥤ󥨥顼 (8bit)
*/
#ifndef _ITRON_ERRNO_
#define	E_OK		0	/* ｪλ */

#define E_SYS		(-5)	/* ƥ२顼 */
#define	E_NOMEM		(-10)	/* ­ */
#define	E_NOSPT		(-17)	/* ̤ݡȵǽ */
#define	E_RSATR		(-24)	/* ͽ° */
#define	E_PAR		(-33)	/* ѥ᥿顼 */
#define	E_ID		(-35)	/* IDֹ */
#define	E_NOEXS		(-52)	/* ֥̤ */
#define	E_OBJ		(-63)	/* ֥Ⱦ֥顼 */
#define	E_MACV		(-65)	/* ꥢȿ */
#define	E_DLT		(-81)	/* Ԥ֥Ȥκ */
#define	E_RLWAI		(-86)	/* Υ󥻥롿Ԥ֤ζ */
#endif /* _ITRON_ERRNO_ */

#define E_CLS           (-87)   /* ³ */

#define E_UNLOCKED      (-88)   /* ǥåƤʤ */

/*
   ֥顼 (8bit)
*/
#define	ES_OK		0	/* ʤ */

/* ף֥ͭȥ󥿡ե (-1 -> -99) */


/* ףȥ꡼।󥿡ե (-100 -> -199) */


/*
   ¸顼 (16bit)
*/
#define	EI_OK		0	/* ʤ */

/* ף֥ͭȥ󥿡ե (-1 -> -99) */


/* ףȥ꡼।󥿡ե (-100 -> -199) */


#ifdef __cplusplus
}
#endif
#endif /* _JTI_ERRNO_H_ */
