/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: jti_priority.c
   Note: JTRON 2.0 ITRON API
Javaåɤȥꥢ륿ॿб
   Date: 1999/9/23
   Last update: 2000/1/5
*/
#include <basic.h>
#include <bstring.h>
#include "if_jt2ext.h"

#include "jti_common.h"
#include "jti_shared.h"
#include "jti_debug.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
   Function: _jti_set_hpr
   Note: JREꥢ륿ॿκǹͥ٤ꤹ롣
*/
EXPORT VOID
_jti_set_hpr (hijpr) 

PRI  hijpr ;	/* (I) ꥢ륿ॿκǹͥ */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (set_hp) _jti_set_hpr");

  /* Make massage */
  send.kind = IA_SET_HPR ;
  send.id = (JNO)hijpr ;
  send.jpri = 0 ;
  DPRINT2("$ (set_hp) Send: kind:[%d], hijpr:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (set_hp)Err: snd_msg: %d\n",er);
    return ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (set_hp) Reply: ercd:[%d]\n",recv.ercd);

  return ;
}

/*
   Function: _jti_get_hpr
   Note: Javaåɤͥ٤顢ꥢ륿ॿͥ٤롣
*/
EXPORT PRI
_jti_get_hpr (hijpr, jpr) 

PRI  hijpr ;	/* (I) JREꥢ륿ॿκǹͥ */
INT  jpr ;	/* (I) Javaåɤͥ */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (get_hp) _jti_get_hpr");

  /* Make massage */
  send.kind = IA_GET_HPR ;
  send.id = (JNO)hijpr ;
  send.jpri = jpr ;
  DPRINT3("$ (get_hp) Send: kind:[%d], hijpr:[%d], jpr:[%d]\n",send.kind,send.id,send.jpri);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (get_hp)Err: snd_msg: %d\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT2("$ (get_hp) Reply: ercd:[%d], jpri:[%d]\n",recv.ercd,recv.jpri);

  return (recv.jpri) ;
}

/*
   Function: _jti_get_lpr
   Note: JREꥢ륿ॿκͥ٤롣
*/
EXPORT PRI
_jti_get_lpr (hijpr) 

PRI  hijpr ;	/* (I) JREꥢ륿ॿκǹͥ */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (get_lp) _jti_get_lpr");

  /* Make massage */
  send.kind = IA_GET_LPR ;
  send.id = (JNO)hijpr ;
  send.jpri = 0 ;
  DPRINT2("$ (get_lp) Send: kind:[%d], hijpr:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (get_lp)Err: snd_msg: %d\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT2("$ (get_lp) Reply: ercd:[%d], pri:[%d]\n",recv.ercd,recv.jpri);

  return (recv.jpri) ;
}

#ifdef __cplusplus
}
#endif
