/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: EventFlag.cc
   Note: EventFlag饹Υͥƥ֥᥽åɷ

   Version
    0.020     1999/10/1  λ꡼С
    0.030     1999/10/

*/

#include <jni.h>

/* JAVAHǺincludeե */
#ifdef JTRON_JAVAH
#include <jp_gr_itron_jtron_attach_EventFlag.h>
#endif
#ifndef JTRON_JAVAH
#include <system_pkgs/jp_gr_itron_jtron_attach_EventFlag.h>
#endif

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JIL */
/* #include <jil_std.h> */
/* JILεǽŪɬפǤϤʤΤbstdlibɤ*/ 

/* JTRON饹 */
#include <jti_common.h>
#include <jti_attach_common.h>

/* Linuxƥ */
#ifdef LINUXDEV
#include <itronstub_extern.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
#include <bstdlib.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ٥ȥե饰å饹Υͥƥ֥᥽åɷ
 */

/* private native int eventflag_exist_jtn(int evfId) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_EventFlag_eventflag_1exist_1jtn
(JNIEnv *env, jobject thisObj, jint flgid)
{
  ER err;

  T_RFLG rflg;

#ifdef JTRON_DEBUG
  printf("> eventflag_exist_jtn(a):flgid=%d\n",flgid);
#endif

  // ꤵ줿IDΥ꥽뤫å롣
  err = ref_flg(&rflg,flgid);

#ifdef JTRON_DEBUG
  printf("> eventflag_exist_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_FLG);
  }

  return (jint)err;
}

/* private native void eventflag_new_jtn(int evfid,T_CFLG cflg) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_EventFlag_eventflag_1new_1jtn
(JNIEnv *env, jobject thisObj, jint flgid, jobject obj_cflg)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CFLG cflg;

#ifdef JTRON_DEBUG
  printf("> call eventflag_new_jtn(int flgid,T_CFLG cflg) flgid=%d\n",flgid);
#endif

  // ǡѥåȤΥå
  if( obj_cflg==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_CRE_FLG);
    return; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cflg);
  fid = env->GetFieldID(clazz,"flgatr","I");
  cflg.flgatr = env->GetIntField(obj_cflg,fid); 
  fid = env->GetFieldID(clazz,"iflgptn","I");
  cflg.iflgptn = env->GetIntField(obj_cflg,fid); 

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall cre_flg(flgid,&cflg) flgid=%d\n",flgid);
  printf("> cflg.flgatr=%d\n",cflg.flgatr);
  printf("> cflg.iflgptn=%d\n",cflg.iflgptn);
#endif
  /* ӥ */
  err = cre_flg(flgid,&cflg);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return cre_flg(flgid,&cflg)\n");
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_CRE_FLG);
  }

#ifdef JTRON_DEBUG
  printf("> call return eventflag_new_jtn(int flgid,T_CFLG cflg)\n");
#endif

}

/* private native int eventflag_newa_jtn(T_CFLG cflg) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_EventFlag_eventflag_1newa_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_cflg)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CFLG cflg;

  // ǡѥåȤΥå
  if( obj_cflg==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_VCRE_FLG);
    return 0; 
  }
  
  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cflg);
  fid = env->GetFieldID(clazz,"flgatr","I");
  cflg.flgatr = env->GetIntField(obj_cflg,fid); 
  fid = env->GetFieldID(clazz,"iflgptn","I");
  cflg.iflgptn = env->GetIntField(obj_cflg,fid); 

  /* ӥ */
  err = vcre_flg(&cflg);

#ifdef JTRON_DEBUG
  printf("> eventflag_newa_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_VCRE_FLG);
  }

  return (jint)err;
}

/* private native void delete_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_EventFlag_delete_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err=del_flg(id);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_DEL_FLG);
  }
}

/* private native void set_jtn(int pattern) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_EventFlag_set_1jtn
(JNIEnv *env, jobject thisObj, jint setptn)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> set_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err = set_flg(id,setptn);

#ifdef JTRON_DEBUG
  printf("> set_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_SET_FLG);
  }
}

/* private native void clear_jtn(int pattern) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_EventFlag_clear_1jtn
(JNIEnv *env, jobject thisObj, jint clrptn)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> clear_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err = clr_flg(id,clrptn);

#ifdef JTRON_DEBUG
  printf("> clear_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_CLR_FLG);
  }

}

/* private native int waitflag_jtn(int waitPattern,int waitMode) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_EventFlag_waitflag_1jtn__II
(JNIEnv *env, jobject thisObj, jint waiptn, jint wfmode)
{
  UINT flgptn;
  ER err;
  int id;

#ifdef JTRON_DEBUG
  printf("> call waitflag_jtn(waitPattern,waitMode) waitPattern=%d waitMode=%d\n",waiptn,wfmode);
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall wai_flg(&flgptn,id,waiptn,wfmode) id=%d\n",id);
#endif
  /* ӥ */
  err = wai_flg(&flgptn,id,waiptn,wfmode);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return wai_flg(&flgptn,id,waiptn,wfmode)\n");
  printf("> flgptn=%d\n",&flgptn);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_WAI_FLG);
  }

#ifdef JTRON_DEBUG
  printf("> call return waitflag_jtn(waitPattern,waitMode)\n");
#endif

  return flgptn;
}

/* private native int waitflag_jtn(int waitPattern,int waitMode,int tmout)*/
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_EventFlag_waitflag_1jtn__III
(JNIEnv *env, jobject thisObj, jint waiptn, jint wfmode, jint tmout)
{
  UINT flgptn;
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> waitflagtimeout_jtn(a):id=%d\n",id);
  printf("> waitflagtimeout_jtn(a):tmout=%d\n",tmout);
#endif

  /* ӥ */
  err = twai_flg(&flgptn,id,waiptn,wfmode,tmout);

#ifdef JTRON_DEBUG
  printf("> waitflagtimeout_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_TWAI_FLG);
  }

  return flgptn;
}

/* private native int poll_jtn(int waitPattern,int waitMode) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_EventFlag_poll_1jtn
(JNIEnv *env, jobject thisObj, jint waiptn, jint wfmode)
{
  UINT flgptn;
  ER err;

  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> poll_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err = pol_flg(&flgptn,id,waiptn,wfmode);

#ifdef JTRON_DEBUG
  printf("> poll_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_POL_FLG);
  }

  /* id ֤ƤΤ flgptn ֤褦˽1999/12/28 */
  return flgptn;
}

/* private native int referstatus_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_EventFlag_referstatus_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_rflg)
{
  ER err;
  T_RFLG rflg;
  int id;
  
  jclass clazz;
  jfieldID fid;

#ifdef JTRON_DEBUG
  printf("> call referstatus_jtn()\n");
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);
  
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall ref_flg(&rflg,id) id=%d\n",id);
#endif
  /* ӥ */
  err = ref_flg(&rflg,id);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return ref_flg(&rflg,id)\n");
  printf("> rflg.wtsk=%d\n",rflg.wtsk);
  printf("> rflg.flgptn=%d\n",rflg.flgptn);
#endif  

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_FLG);
    return;
  }

  clazz = env->GetObjectClass(obj_rflg);
  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rflg,fid,rflg.wtsk);
  
  fid = env->GetFieldID(clazz,"flgptn","I");
  env->SetIntField(obj_rflg,fid,rflg.flgptn);

#ifdef JTRON_DEBUG
  printf("> call return referstatus_jtn()\n");
#endif

}

#ifdef __cplusplus
}
#endif
