/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: ItronApi.cc
   Note: ITRONߴAPI饹

   Version
    0.020     1999/10/1  λ꡼С
    0.030     1999/10/

*/

#include <jni.h>

/* JAVAHǺincludeե */
#ifdef JTRON_JAVAH
#include <jp_gr_itron_jtron_attach_ItronApi.h>
#endif
#ifndef JTRON_JAVAH
#include <system_pkgs/jp_gr_itron_jtron_attach_ItronApi.h>
#endif

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JIL */
/* #include <jil_std.h> */
/* JILεǽŪɬפǤϤʤΤbstdlibɤ*/

/* JTRON饹 */
#include <jti_common.h>
#include <jti_attach_common.h>

/* Linuxƥ */
#ifdef LINUXDEV
#include <stdlib.h>
#include <itronstub_extern.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
#include <bstdlib.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ǥ֥ݡȴط
 */

/* ref_por */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_ref_1por
(JNIEnv *env, jclass thisClass, jobject obj_rpor, jint portid)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_RPOR rpor;

  // ǡѥåȤΥå
  if( obj_rpor==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> ref_por(a):portid=%d\n",portid);
#endif

  /* ӥ */
  rv = ref_por(&rpor,portid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> ref_por(a):rv=%d\n",rv);
  printf("> ref_por(a):wtsk=%d\n",rpor.wtsk);
  printf("> ref_por(a):atsk=%d\n",rpor.atsk);
#endif

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rpor);
  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rpor,fid,rpor.wtsk);
  fid = env->GetFieldID(clazz,"atsk","I");
  env->SetIntField(obj_rpor,fid,rpor.atsk);

  return (jint)rv;
}

/* rpl_rdv */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_rpl_1rdv
(JNIEnv *env, jclass thisClass, jint rdvno, jobject obj_im, jint rsize)
{
  ER rv;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

#ifdef JTRON_DEBUG
  printf("> rpl_rdv(a):address=%x\n",(char *)vp);
  printf("> rpl_rdv(a):rsize=%x\n",rsize);
#endif

  /* ӥ */
  rv=rpl_rdv(rdvno,vp,rsize);

#ifdef JTRON_DEBUG
  printf("> rpl_rdv(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* fwd_por */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_fwd_1por
(JNIEnv *env, jclass thisClass, jint portid, jint calptn, jint rdvno, jobject obj_im, jint csize)
{
  ER rv;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

#ifdef JTRON_DEBUG
  printf("> fwd_por(a):portid=%d\n",portid);
  printf("> fwd_por(a):calptn=%d\n",calptn);
  printf("> fwd_por(a):address=%x\n",(char *)vp);
  printf("> fwd_por(a):csize=%d\n",csize);
  printf("> fwd_por(a):rdvno=%d\n",rdvno);
#endif

  /* ӥ */
  rv=fwd_por(portid,calptn,rdvno,vp,csize);

#ifdef JTRON_DEBUG
  printf("> fwd_por(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* tacp_por */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_tacp_1por
(JNIEnv *env, jclass thisClass, jobject obj_rdvno, jobject obj_im, jobject obj_csize, jint portid, jint acpptn, jint tmout)
{
  ER rv;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;
  INT rsize;
  RNO rdvno;
  INT csize;

  // ǡѥåȤΥå
  if( obj_csize==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_rdvno==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }
  

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

#ifdef JTRON_DEBUG
  printf("> tacp_por(a):porid=%d\n",portid);
  printf("> tacp_por(a):acpptn=%d\n",acpptn);
  printf("> tacp_por(a):tmout=%d\n",tmout);
#endif

  /* ӥ */
  rv=tacp_por(&rdvno,vp,&csize,portid,acpptn,tmout);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> tacp_por(a):rv=%d\n",rv);
  printf("> tacp_por(a):rdvno=%d\n",rdvno);
  printf("> tacp_por(a):address=%x\n",(char *)vp);
  printf("> tacp_por(a):csize=%d\n",csize);
#endif

  /* ǥֹobj_rdvno˥å */
  clazz = env->GetObjectClass(obj_rdvno);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_rdvno,fid,rdvno);

  /* դåĹcsizeobj_csize˥å */
  clazz = env->GetObjectClass(obj_csize);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_csize,fid,csize);

  return (jint)rv;
}

/* pacp_por */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_pacp_1por
(JNIEnv *env, jclass thisClass, jobject obj_rdvno, jobject obj_im, jobject obj_csize, jint portid, jint acpptn)
{
  ER rv;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;
  INT rsize;
  RNO rdvno;
  INT csize;

  // ǡѥåȤΥå
  if( obj_csize==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_rdvno==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

#ifdef JTRON_DEBUG
  printf("> pacp_por(a):porid=%d\n",portid);
  printf("> pacp_por(a):acpptn=%d\n",acpptn);
#endif

  /* ӥ */
  rv=pacp_por(&rdvno,vp,&csize,portid,acpptn);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> pacp_por(a):rv=%d\n",rv);
  printf("> pacp_por(a):rdvno=%d\n",rdvno);
  printf("> pacp_por(a):address=%x\n",(char *)vp);
  printf("> pacp_por(a):csize=%d\n",csize);
#endif

  /* ǥֹobj_rdvno˥å */
  clazz = env->GetObjectClass(obj_rdvno);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_rdvno,fid,rdvno);

  /* դåĹcsizeobj_csize˥å */
  clazz = env->GetObjectClass(obj_csize);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_csize,fid,csize);

  return (jint)rv;
}

/* acp_por */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_acp_1por
(JNIEnv *env, jclass thisClass, jobject obj_rdvno, jobject obj_im, jobject obj_csize, jint portid, jint acpptn)
{
  ER rv;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;
  INT rsize;
  RNO rdvno;
  INT csize;

  // ǡѥåȤΥå
  if( obj_csize==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_rdvno==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

#ifdef JTRON_DEBUG
  printf("> acp_por(a):porid=%d\n",portid);
  printf("> acp_por(a):acpptn=%d\n",acpptn);
#endif

  /* ӥ */
  rv=acp_por(&rdvno,vp,&csize,portid,acpptn);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> acp_por(a):rv=%d\n",rv);
  printf("> acp_por(a):rdvno=%d\n",rdvno);
  printf("> acp_por(a):address=%x\n",(char *)vp);
  printf("> acp_por(a):csize=%d\n",csize);
#endif

  /* ǥֹobj_rdvno˥å */
  clazz = env->GetObjectClass(obj_rdvno);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_rdvno,fid,rdvno);

  /* դåĹcsizeobj_csize˥å */
  clazz = env->GetObjectClass(obj_csize);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_csize,fid,csize);

  return (jint)rv;
}

/* tcal_por */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_tcal_1por
(JNIEnv *env, jclass thisClass, jobject obj_im, jobject obj_rsize, jint porid, jint calptn, jint csize, jint tmout)
{
  ER rv;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;
  INT rsize;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_rsize==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

#ifdef JTRON_DEBUG
  printf("> pcal_por(a):porid=%d\n",porid);
  printf("> pcal_por(a):calptn=%d\n",calptn);
  printf("> pcal_por(a):csize=%d\n",csize);
  printf("> pcal_por(a):tmout=%d\n",tmout);
#endif

  /* ӥ */
  rv=tcal_por(vp,&rsize,porid,calptn,csize,tmout);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> pcal_por(a):rv=%d\n",rv);
  printf("> pcal_por(a):rsize=%d\n",rsize);
  printf("> pcal_por(a):address=%x\n",(char *)vp);
#endif

  /* åƱƤӽФåƱɥ쥹äƤ롣 
    ΤItronMemory˥ɥ쥹򥻥åȤľɬפϤʤ */

  /* դåĹrsizeobj_rsize˥å */
  clazz = env->GetObjectClass(obj_rsize);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_rsize,fid,rsize);

  return (jint)rv;
}

/* pcal_por */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_pcal_1por
(JNIEnv *env, jclass thisClass, jobject obj_im, jobject obj_rsize, jint porid, jint calptn, jint csize)
{
  ER rv;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;
  INT rsize;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_rsize==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

#ifdef JTRON_DEBUG
  printf("> pcal_por(a):porid=%d\n",porid);
  printf("> pcal_por(a):calptn=%d\n",calptn);
  printf("> pcal_por(a):csize=%d\n",csize);
#endif

  /* ӥ */
  rv=pcal_por(vp,&rsize,porid,calptn,csize);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> pcal_por(a):rv=%d\n",rv);
  printf("> pcal_por(a):rsize=%d\n",rsize);
  printf("> pcal_por(a):address=%x\n",(char *)vp);
#endif

  /* åƱƤӽФåƱɥ쥹äƤ롣 
    ΤItronMemory˥ɥ쥹򥻥åȤľɬפϤʤ */

  /* դåĹrsizeobj_rsize˥å */
  clazz = env->GetObjectClass(obj_rsize);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_rsize,fid,rsize);

  return (jint)rv; 
}

/* cal_por */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_cal_1por
(JNIEnv *env, jclass thisClass, jobject obj_im, jobject obj_rsize, jint porid, jint calptn, jint csize)
{
  ER rv;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;
  INT rsize;

    // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_rsize==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

#ifdef JTRON_DEBUG
  printf("> cal_por(a):porid=%d\n",porid);
  printf("> cal_por(a):calptn=%d\n",calptn);
  printf("> cal_por(a):csize=%d\n",csize);
#endif

  /* ӥ */
  rv=cal_por(vp,&rsize,porid,calptn,csize);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> cal_por(a):rv=%d\n",rv);
  printf("> cal_por(a):rsize=%d\n",rsize);
  printf("> cal_por(a):address=%x\n",(char *)vp);
#endif

  /* åƱƤӽФåƱɥ쥹äƤ롣 
    ΤItronMemory˥ɥ쥹򥻥åȤľɬפϤʤ */

  /* դåĹrsizeobj_rsize˥å */
  clazz = env->GetObjectClass(obj_rsize);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_rsize,fid,rsize);

  return (jint)rv;
}

/* del_por */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_del_1por
(JNIEnv *env, jclass thisClass, jint portid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> del_por(a):portid=%d\n",portid);
#endif

  /* ӥ */
  rv = del_por(portid);

#ifdef JTRON_DEBUG
  printf("> del_por(a):rv=%d\n",rv);
#endif

  return (jint)rv; 
}

/* cre_por */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_cre_1por
(JNIEnv *env, jclass thisClass, jint portid, jobject obj_cpor)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CPOR cpor;

  // ǡѥåȤΥå
  if( obj_cpor==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cpor);
  fid = env->GetFieldID(clazz,"poratr","I");
  cpor.poratr = env->GetIntField(obj_cpor,fid); 
  fid = env->GetFieldID(clazz,"maxcmsz","I");
  cpor.maxcmsz = env->GetIntField(obj_cpor,fid);
  fid = env->GetFieldID(clazz,"maxrmsz","I");
  cpor.maxrmsz = env->GetIntField(obj_cpor,fid);

#ifdef JTRON_DEBUG
  printf("> cre_por(a):portid=%d\n",portid);
  printf("> cre_por(a):poratr=%d\n",cpor.poratr);
  printf("> cre_por(a):maxcmsz=%d\n",cpor.maxcmsz);
  printf("> cre_por(a):maxrmsz=%d\n",cpor.maxrmsz);
#endif

  /* ӥ */
  rv = cre_por(portid,&cpor); 

#ifdef JTRON_DEBUG
  printf("> cre_por(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* vcre_por */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_vcre_1por
(JNIEnv *env, jclass thisClass, jobject obj_cpor)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CPOR cpor;

  // ǡѥåȤΥå
  if( obj_cpor==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cpor);
  fid = env->GetFieldID(clazz,"poratr","I");
  cpor.poratr = env->GetIntField(obj_cpor,fid); 
  fid = env->GetFieldID(clazz,"maxcmsz","I");
  cpor.maxcmsz = env->GetIntField(obj_cpor,fid);
  fid = env->GetFieldID(clazz,"maxrmsz","I");
  cpor.maxrmsz = env->GetIntField(obj_cpor,fid);

#ifdef JTRON_DEBUG
  printf("> vcre_por(a):poratr=%d\n",cpor.poratr);
  printf("> vcre_por(a):maxcmsz=%d\n",cpor.maxcmsz);
  printf("> vcre_por(a):maxrmsz=%d\n",cpor.maxrmsz);
#endif

    /* ӥ */
  rv = vcre_por(&cpor); 

#ifdef JTRON_DEBUG
  printf("> vcre_por(a):rv=%d\n",rv);
#endif

  return (jint)rv;

}


/*
 *  Ĺסط
 */

/* ref_mpf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_ref_1mpf
(JNIEnv *env, jclass thisClass, jobject obj_rmpf, jint mpfid)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_RMPF rmpf;

  // ǡѥåȤΥå
  if( obj_rmpf==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> ref_mpf(a):mplid=%d\n",mpfid);
#endif

  /* ӥ */
  rv = ref_mpf(&rmpf,mpfid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> ref_mpf(a):rv=%d\n",rv);
  printf("> ref_mpf(a):wtsk=%d\n",rmpf.wtsk);
  printf("> ref_mpf(a):frbcnt=%d\n",rmpf.frbcnt);
#endif

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rmpf);
  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rmpf,fid,rmpf.wtsk);
  fid = env->GetFieldID(clazz,"frbcnt","I");
  env->SetIntField(obj_rmpf,fid,rmpf.frbcnt);

  return (jint)rv;
}

/* rel_blf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_rel_1blf
(JNIEnv *env, jclass thisClass, jint mpfid, jobject obj_im)
{
  ER rv;
  jint ad_i;
  VP vp;

  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);
  
  /* ӥ */
  rv=rel_blf(mpfid,vp);

  return (jint)rv;
}

/* tget_blf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_tget_1blf
(JNIEnv *env, jclass thisClass, jobject obj_im, jint mpfid, jint tmout)
{
  VP vp;
  jint ad_i;
  ER rv;
  
  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> tget_blf(a):mplid=%d\n",mpfid);
  printf("> tget_blf(a):tmout=%d\n",tmout);
#endif

  /* ӥ */
  rv=tget_blf(&vp,mpfid,tmout);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> tget_blf(a):rv=%d\n",rv);
  printf("> tget_blf(a):address=%x\n",vp);
#endif

  /* ΰξItronMemory˥å */
  setAddr_jtc(env,obj_im,vp);

  /* ĹǤʤʬǺϲǽ? */
  // ΰ西פ
  setMemType_jtc(env,obj_im,MTYPE_ITRON_NOLEN);

  return (jint)rv;
}

/* pget_blf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_pget_1blf
(JNIEnv *env, jclass thisClass, jobject obj_im, jint mpfid)
{
  VP vp;
  jint ad_i;
  ER rv;
  
  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> tget_blf(a):mplid=%d\n",mpfid);
#endif

  /* ӥ */
  rv=pget_blf(&vp,mpfid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> tget_blf(a):rv=%d\n",rv);
  printf("> tget_blf(a):address=%x\n",vp);
#endif

  /* ΰξItronMemory˥å */
  setAddr_jtc(env,obj_im,vp);

  /* ĹǤʤʬǺϲǽ? */
  // ΰ西פ
  setMemType_jtc(env,obj_im,MTYPE_ITRON_NOLEN);

  return (jint)rv;
}

/* get_blf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_get_1blf
(JNIEnv *env, jclass thisClass, jobject obj_im, jint mpfid)
{
  VP vp;
  jint ad_i;
  ER rv;
  
  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> tget_blf(a):mplid=%d\n",mpfid);
#endif

  /* ӥ */
  rv=get_blf(&vp,mpfid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> tget_blf(a):rv=%d\n",rv);
  printf("> tget_blf(a):address=%x\n",vp);
#endif

  /* ΰξItronMemory˥å */
  setAddr_jtc(env,obj_im,vp);

  /* ĹǤʤʬǺϲǽ? */
  // ΰ西פ
  setMemType_jtc(env,obj_im,MTYPE_ITRON_NOLEN);

  return (jint)rv;
}

/* del_mpf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_del_1mpf
(JNIEnv *env, jclass thisClass, jint mpfid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> del_mpf(a):mpfid=%d\n",mpfid);
#endif

  /* ӥ */
  rv = del_mpf(mpfid);

#ifdef JTRON_DEBUG
  printf("> del_mpf(a):rv=%d\n",rv);
#endif

  return (jint)rv;  
}

/* cre_mpf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_cre_1mpf
(JNIEnv *env, jclass thisClass, jint mpfid, jobject obj_cmpf)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CMPF cmpf;

  // ǡѥåȤΥå
  if( obj_cmpf==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmpf);
  fid = env->GetFieldID(clazz,"mpfatr","I");
  cmpf.mpfatr = env->GetIntField(obj_cmpf,fid); 
  fid = env->GetFieldID(clazz,"mpfcnt","I");
  cmpf.mpfcnt = env->GetIntField(obj_cmpf,fid); 
  fid = env->GetFieldID(clazz,"blfsz","I");
  cmpf.blfsz = env->GetIntField(obj_cmpf,fid); 

#ifdef JTRON_DEBUG
  printf("> cre_mpf(a):mpfid=%d\n",mpfid);
  printf("> cre_mpf(a):mpfatr=%d\n",cmpf.mpfatr);
  printf("> cre_mpf(a):mpfcnt=%d\n",cmpf.mpfcnt);
  printf("> cre_mpf(a):blfsz=%d\n",cmpf.blfsz);
#endif

  /* ӥ */
  rv = cre_mpf(mpfid,&cmpf); 

#ifdef JTRON_DEBUG
  printf("> cre_mpf(a):rv=%d\n",rv);
#endif

  return (jint)rv; 
}

/* vcre_mpf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_vcre_1mpf
(JNIEnv *env, jclass thisClass, jobject obj_cmpf) 
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CMPF cmpf;

  // ǡѥåȤΥå
  if( obj_cmpf==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmpf);
  fid = env->GetFieldID(clazz,"mpfatr","I");
  cmpf.mpfatr = env->GetIntField(obj_cmpf,fid); 
  fid = env->GetFieldID(clazz,"mpfcnt","I");
  cmpf.mpfcnt = env->GetIntField(obj_cmpf,fid); 
  fid = env->GetFieldID(clazz,"blfsz","I");
  cmpf.blfsz = env->GetIntField(obj_cmpf,fid); 

#ifdef JTRON_DEBUG
  printf("> vcre_mpf(a):mpfatr=%d\n",cmpf.mpfatr);
  printf("> vcre_mpf(a):mpfcnt=%d\n",cmpf.mpfcnt);
  printf("> vcre_mpf(a):blfsz=%d\n",cmpf.blfsz);
#endif

  /* ӥ */
  rv = vcre_mpf(&cmpf); 

#ifdef JTRON_DEBUG
  printf("> vcre_mpf(a):rv=%d\n",rv);
#endif

  return (jint)rv; 
}

/*
 *  Ĺסط
 */

/* ref_mpl */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_ref_1mpl
(JNIEnv *env, jclass thisClass, jobject obj_rmpl, jint mplid)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_RMPL rmpl;

  // ǡѥåȤΥå
  if( obj_rmpl==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> ref_mpl(a):mplid=%d\n",mplid);
#endif

  /* ӥ */
  rv = ref_mpl(&rmpl,mplid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> ref_mpl(a):rv=%d\n",rv);
  printf("> ref_mpl(a):wtsk=%x\n",rmpl.wtsk);
  printf("> ref_mpl(a):frsz=%x\n",rmpl.frsz);
  printf("> ref_mpl(a):maxsz=%x\n",rmpl.maxsz);
#endif

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rmpl);
  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rmpl,fid,rmpl.wtsk);
  fid = env->GetFieldID(clazz,"frsz","I");
  env->SetIntField(obj_rmpl,fid,rmpl.frsz);
  fid = env->GetFieldID(clazz,"maxsz","I");
  env->SetIntField(obj_rmpl,fid,rmpl.maxsz);

  return (jint)rv;
}

/* rel_blk */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_rel_1blk
(JNIEnv *env, jclass thisClass, jint mplid, jobject obj_im)
{
  ER rv;
  jint ad_i;
  VP vp;

  jclass clazz;
  jfieldID fid;

   // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }
 
  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);
  
  /* ӥ */
  rv=rel_blk(mplid,vp);

  return (jint)rv;

}

/* tget_blk */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_tget_1blk
(JNIEnv *env, jclass thisClass, jobject obj_im, jint mplid, jint blksz, jint tmout)
{
  VP vp;
  ER rv;
  
  jclass clazz;
  jfieldID fid;
  jint ad_i;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> tget_blk(a):mplid=%d\n",mplid);
  printf("> tget_blk(a):blksz=%d\n",blksz);
  printf("> tget_blk(a):tmout=%d\n",tmout);
#endif

  /* ӥ */
  rv=tget_blk(&vp,mplid,blksz,tmout);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> tget_blk(a):rv=%d\n",rv);
  printf("> tget_blk(a):address=%x\n",vp);
#endif

  /* ΰξItronMemory˥å */
  setAddr_jtc(env,obj_im,vp);
  /* ΰĹItronMemory˥å */
  setMemLen_jtc(env,obj_im,blksz);
  // ΰ西פ
  setMemType_jtc(env,obj_im,MTYPE_MEMPOOL);

  return (jint)rv; 
}

/* pget_blk */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_pget_1blk
(JNIEnv *env, jclass thisClass, jobject obj_im, jint mplid, jint blksz)
{
  VP vp;
  ER rv;
  
  jclass clazz;
  jfieldID fid;
  jint ad_i;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> get_blk(a):mplid=%d\n",mplid);
  printf("> get_blk(a):blksz=%d\n",blksz);
#endif

  /* ӥ */
  rv=pget_blk(&vp,mplid,blksz);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> get_blk(a):rv=%d\n",rv);
  printf("> get_blk(a):address=%x\n",vp);
#endif

  /* ΰξItronMemory˥å */
  setAddr_jtc(env,obj_im,vp);
  setMemLen_jtc(env,obj_im,blksz);
  setMemType_jtc(env,obj_im,MTYPE_MEMPOOL);

  return (jint)rv; 
}

/* get_blk */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_get_1blk
(JNIEnv *env, jclass thisClass, jobject obj_im, jint mplid, jint blksz)
{
  VP vp;
  ER rv;
  
  jclass clazz;
  jfieldID fid;
  jint ad_i;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> get_blk(a):mplid=%d\n",mplid);
  printf("> get_blk(a):blksz=%d\n",blksz);
#endif

  /* ӥ */
  rv=get_blk(&vp,mplid,blksz);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> get_blk(a):rv=%d\n",rv);
  printf("> get_blk(a):address=%x\n",vp);
#endif

  /* ΰξItronMemory˥å */
  setAddr_jtc(env,obj_im,vp);
  setMemLen_jtc(env,obj_im,blksz);
  setMemType_jtc(env,obj_im,MTYPE_MEMPOOL);

  return (jint)rv; 
}

/* del_mpl */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_del_1mpl
(JNIEnv *env, jclass thisClass, jint mplid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> del_mpl(a):mplid=%d\n",mplid);
#endif

  /* ӥ */
  rv = del_mpl(mplid);

#ifdef JTRON_DEBUG
  printf("> del_mpl(a):rv=%d\n",rv);
#endif

  return (jint)rv; 
}

/* vcre_mpl */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_vcre_1mpl
(JNIEnv *env, jclass thisClass, jobject obj_cmpl)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CMPL cmpl;

  // ǡѥåȤΥå
  if( obj_cmpl==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmpl);
  fid = env->GetFieldID(clazz,"mplatr","I");
  cmpl.mplatr  = env->GetIntField(obj_cmpl,fid);
  fid = env->GetFieldID(clazz,"mplsz","I");
  cmpl.mplsz = env->GetIntField(obj_cmpl,fid);

#ifdef JTRON_DEBUG
  printf("> vcre_mpl(a):mplatr=%d\n",cmpl.mplatr);
  printf("> vcre_mpl(a):mplsz=%d\n",cmpl.mplsz);
#endif

  /* ӥ */
  rv = vcre_mpl(&cmpl); 

#ifdef JTRON_DEBUG
  printf("> vcre_mpl(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* cre_mpl */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_cre_1mpl
(JNIEnv *env, jclass thisClass, jint mplid, jobject obj_cmpl)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CMPL cmpl;

  // ǡѥåȤΥå
  if( obj_cmpl==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmpl);
  fid = env->GetFieldID(clazz,"mplatr","I");
  cmpl.mplatr  = env->GetIntField(obj_cmpl,fid);
  fid = env->GetFieldID(clazz,"mplsz","I");
  cmpl.mplsz = env->GetIntField(obj_cmpl,fid);

#ifdef JTRON_DEBUG
  printf("> cre_mpl(a):mplid=%d\n",mplid);
  printf("> cre_mpl(a):mplatr=%d\n",cmpl.mplatr);
  printf("> cre_mpl(a):mplsz=%d\n",cmpl.mplsz);
#endif

  /* ӥ */
  rv = cre_mpl(mplid,&cmpl); 

#ifdef JTRON_DEBUG
  printf("> cre_mpl(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/*
 *  åХåեط
 */

/* ena_int */
/* BrightVʤ */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_ena_1int
(JNIEnv *env, jclass thisClass, jint eintno) 
{
  ER rv;

  /*
  rv = ena_int(eintno);
  */

  return (jint)E_NOSPT;
}

/* dis_int */
/* BrgihtVʤ */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_dis_1int
(JNIEnv *env, jclass thisClass, jint eintno)
{
  ER rv;

  /*
  rv = dis_int(eintno);
  */

  return (jint)E_NOSPT;  
}

/* unl_cpu */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_unl_1cpu
(JNIEnv *env, jclass thisClass)
{
  
  ER rv;

  /* ӥ */
  rv = unl_cpu();

#ifdef JTRON_DEBUG
  printf("> unl_cpu(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* loc_cpu */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_loc_1cpu
(JNIEnv *env, jclass thisClass) 
{
  
  ER rv;

  /* ӥ */
  rv = loc_cpu();

#ifdef JTRON_DEBUG
  printf("> loc_cpu(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* ref_mbf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_ref_1mbf
(JNIEnv *env, jclass thisClass, jobject obj_rmbf, jint mbfid)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_RMBF rmbf; 

  // ǡѥåȤΥå
  if( obj_rmbf==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> ref_mbf(a):mbfid=%d\n",mbfid);
#endif

  /* ӥ */
  rv = ref_mbf(&rmbf,mbfid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> ref_mbf(a):rv=%d\n",rv);
  printf("> ref_mbf(a):rmbf.wtsk=%d\n",rmbf.wtsk);
  printf("> ref_mbf(a):rmbf.stsk=%d\n",rmbf.stsk);
  printf("> ref_mbf(a):rmbf.msgsz=%d\n",rmbf.msgsz);
  printf("> ref_mbf(a):rmbf.frbufsz=%d\n",rmbf.frbufsz);
#endif

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rmbf);
  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rmbf,fid,rmbf.wtsk);
  fid = env->GetFieldID(clazz,"stsk","I");
  env->SetIntField(obj_rmbf,fid,rmbf.stsk);
  fid = env->GetFieldID(clazz,"msgsz","I");
  env->SetIntField(obj_rmbf,fid,rmbf.msgsz);
  fid = env->GetFieldID(clazz,"frbufsz","I");
  env->SetIntField(obj_rmbf,fid,rmbf.frbufsz);

  return (jint)rv;
}

/* trcv_mbf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_trcv_1mbf
(JNIEnv *env, jclass thisClass, jobject obj_im, jobject obj_i, jint mbfid, jint tmout)
{
  T_RMBF rmbf;
  ER rv;
  INT msgsz;
  VP msg;
  jint ad_i;
  
  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_i==NULL) {
      return (jint)E_PAR; 
  }

  /* ΰ襵η */
  rv=ref_mbf(&rmbf,mbfid);
  if(rv<0) {
    return (jint)rv;
  }
  msgsz=rmbf.msgsz;

  /* ΰγ */
  msg = (VP)malloc(msgsz);

#ifdef JTRON_DEBUG
  printf("> trcv_mbf(a):mbdif=%d\n",mbfid);
  printf("> trcv_mbf(a):msgsz=%d\n",msgsz);
  printf("> trcv_mbf(a):tmout=%d\n",tmout);
  printf("> trcv_mbf(a):msg(address)=%x\n",(char *)msg);
#endif

  /* ӥ */
  rv=trcv_mbf(msg,&msgsz,mbfid,tmout);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> trcv_mbf(a):rv=%d\n",rv);
  printf("> trcv_mbf(b):msgsz=%d\n",msgsz);
#endif

  /* ΰƬΤJava֤ItronMemory˥ɥ쥹򥻥å */
  setAddr_jtc(env,obj_im,(void *)msg);
  /* ΰĹItronMemory˥å */
  setMemLen_jtc(env,obj_im,msgsz);  
  setMemType_jtc(env,obj_im,MTYPE_ALLOC);

  /* åĹΥå */

  /* åĹJava֤*/
  clazz = env->GetObjectClass(obj_i);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_i,fid,msgsz);  

  return (jint)rv;
}

/* prcv_mbf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_prcv_1mbf
(JNIEnv *env, jclass thisClass, jobject obj_im, jobject obj_i, jint mbfid)
{
  T_RMBF rmbf;
  ER rv;
  INT msgsz;
  VP msg;
  jint ad_i;
  
  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_i==NULL) {
      return (jint)E_PAR; 
  }

  /* ΰ襵η */
  rv=ref_mbf(&rmbf,mbfid);
  if(rv<0) {
    return (jint)rv;
  }
  msgsz=rmbf.msgsz;

  /* ΰγ */
  msg = (VP)malloc(msgsz);

#ifdef JTRON_DEBUG
  printf("> prcv_mbf(a):mbdif=%d\n",mbfid);
  printf("> prcv_mbf(a):msgsz=%d\n",msgsz);
  printf("> prcv_mbf(a):msg(address)=%x\n",(char *)msg);
#endif

  /* ӥ */
  rv=prcv_mbf(msg,&msgsz,mbfid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> prcv_mbf(a):rv=%d\n",rv);
  printf("> prcv_mbf(b):msgsz=%d\n",msgsz);
#endif

  /* ΰƬΤJava֤ItronMemory˥ɥ쥹򥻥å */
  setAddr_jtc(env,obj_im,(void *)msg);
  /* ΰĹItronMemory˥å */
  setMemLen_jtc(env,obj_im,msgsz);  
  setMemType_jtc(env,obj_im,MTYPE_ALLOC);

  /* åĹΥå */

  /* åĹJava֤*/
  clazz = env->GetObjectClass(obj_i);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_i,fid,msgsz);  

  return (jint)rv;
}

/* rcv_mbf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_rcv_1mbf
(JNIEnv *env, jclass thisClass, jobject obj_im, jobject obj_i, jint mbfid)
{
  T_RMBF rmbf;
  ER rv;
  INT msgsz;
  VP msg;
  jint ad_i;
  
  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }
  if( obj_i==NULL) {
      return (jint)E_PAR; 
  }

  /* ΰ襵η */
  rv=ref_mbf(&rmbf,mbfid);
  if(rv<0) {
    return (jint)rv;
  }
  msgsz=rmbf.msgsz;

  /* ΰγ */
  msg = (VP)malloc(msgsz);

#ifdef JTRON_DEBUG
  printf("> rcv_mbf(a):mbdif=%d\n",mbfid);
  printf("> rcv_mbf(a):msgsz=%d\n",msgsz);
  printf("> rcv_mbf(a):msg(address)=%x\n",(char *)msg);
#endif

  /* ӥ */
  rv=rcv_mbf(msg,&msgsz,mbfid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> rcv_mbf(a):rv=%d\n",rv);
  printf("> rcv_mbf(b):msgsz=%d\n",msgsz);
#endif

  /* ΰƬΤJava֤ItronMemory˥ɥ쥹򥻥å */
  setAddr_jtc(env,obj_im,(void *)msg);
  /* ΰĹItronMemory˥å */
  setMemLen_jtc(env,obj_im,msgsz);  
  setMemType_jtc(env,obj_im,MTYPE_ALLOC);

  /* åĹΥå */

  /* åĹJava֤*/
  clazz = env->GetObjectClass(obj_i);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_i,fid,msgsz);  

  return (jint)rv;

}

/* tsnd_mbf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_tsnd_1mbf
(JNIEnv *env, jclass thisClass, jint mbfid, jobject obj_im, jint msgsz, jint tmout)
{
  ER rv;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

  /* ӥ */
  rv=tsnd_mbf(mbfid,vp,msgsz,tmout);

  return (jint)rv;  
}

/* psnd_mbf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_psnd_1mbf
(JNIEnv *env, jclass thisClass, jint mbfid, jobject obj_im, jint msgsz)
{
  ER rv;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

#ifdef JTRON_DEBUG
  printf("> psnd_mbf(a):mbfid=%d\n",mbfid);
  printf("> psnd_mbf(a):address=%x\n",(char *)vp);
  printf("> psnd_mbf(a):msgsz=%d\n",msgsz);
#endif

  /* ӥ */
  rv=psnd_mbf(mbfid,vp,msgsz);

#ifdef JTRON_DEBUG
  printf("> snd_mbf(a):rv=%d\n",rv);
#endif

  return (jint)rv;   
}

/* snd_mbf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_snd_1mbf
(JNIEnv *env, jclass thisClass, jint mbfid, jobject obj_im, jint msgsz)
{
  ER rv;
  jint ad_i;
  VP vp;
  
  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

#ifdef JTRON_DEBUG
  printf("> snd_mbf(a):mbfid=%d\n",mbfid);
  printf("> snd_mbf(a):address=%x\n",(char *)vp);
  printf("> snd_mbf(a):msgsz=%d\n",msgsz);
#endif

  /* ӥ */
  rv=snd_mbf(mbfid,vp,msgsz);

#ifdef JTRON_DEBUG
  printf("> snd_mbf(a):rv=%d\n",rv);
#endif

  return (jint)rv;  
}

/* del_mbf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_del_1mbf
(JNIEnv *env, jclass thisClass, jint mbfid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> del_mbf(a):mbfid=%d\n",mbfid);
#endif

  /* ӥ */
  rv = del_mbf(mbfid);

#ifdef JTRON_DEBUG
  printf("> del_mbf(a):rv=%d\n",rv);
#endif

  return (jint)rv;  
}

/* vcre_mbf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_vcre_1mbf
(JNIEnv *env, jclass thisClass, jobject obj_cmbf)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CMBF cmbf;

  // ǡѥåȤΥå
  if( obj_cmbf==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmbf);
  fid = env->GetFieldID(clazz,"mbfatr","I");
  cmbf.mbfatr = env->GetIntField(obj_cmbf,fid);
  fid = env->GetFieldID(clazz,"bufsz","I");
  cmbf.bufsz = env->GetIntField(obj_cmbf,fid);
  fid = env->GetFieldID(clazz,"maxmsz","I");
  cmbf.maxmsz = env->GetIntField(obj_cmbf,fid);

#ifdef JTRON_DEBUG
  printf("> vcre_mbf(a):cmbf.mbfatr=%d\n",cmbf.mbfatr);
  printf("> vcre_mbf(a):cmbf.bufsz=%d\n",cmbf.bufsz);
  printf("> vcre_mbf(a):cmbf.maxmsz=%d\n",cmbf.maxmsz);
#endif

  /* ӥ */
  rv = vcre_mbf(&cmbf); 

#ifdef JTRON_DEBUG
  printf("> vcre_mbf(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* cre_mbf */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_cre_1mbf
(JNIEnv *env, jclass thisClass, jint mbfid, jobject obj_cmbf)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CMBF cmbf;

  // ǡѥåȤΥå
  if( obj_cmbf==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmbf);
  fid = env->GetFieldID(clazz,"mbfatr","I");
  cmbf.mbfatr = env->GetIntField(obj_cmbf,fid);
  fid = env->GetFieldID(clazz,"bufsz","I");
  cmbf.bufsz = env->GetIntField(obj_cmbf,fid);
  fid = env->GetFieldID(clazz,"maxmsz","I");
  cmbf.maxmsz = env->GetIntField(obj_cmbf,fid);

#ifdef JTRON_DEBUG
  printf("> cre_mbf(a):mbfid=%d\n",mbfid);
  printf("> cre_mbf(a):cmbf.mbfatr=%d\n",cmbf.mbfatr);
  printf("> cre_mbf(a):cmbf.bufsz=%d\n",cmbf.bufsz);
  printf("> cre_mbf(a):cmbf.maxmsz=%d\n",cmbf.maxmsz);
#endif

  /* ӥ */
  rv = cre_mbf(mbfid,&cmbf); 

#ifdef JTRON_DEBUG
  printf("> cre_mbf(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/*
 *  ᡼ܥåط
 */

/* ref_mbx */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_ref_1mbx
(JNIEnv *env, jclass thisClass, jobject obj_rmbx, jint mbxid)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_RMBX rmbx;

  // ǡѥåȤΥå
  if( obj_rmbx==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> ref_mbx(a):mbxid=%d\n",mbxid);
#endif

  /* ӥ */
  rv = ref_mbx(&rmbx,mbxid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> ref_mbx(a):rv=%d\n",rv);
  printf("> ref_mbx(a):wtsk=%d\n",rmbx.wtsk);
#endif

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rmbx);
  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rmbx,fid,rmbx.wtsk);

  return (jint)rv;
}

/* snd_msg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_snd_1msg
(JNIEnv *env, jclass thisClass, jint mbxid, jobject obj_im)
{
  ER rv;
  T_MSG *p_msg;
  char *im_cp;
  jint ad_i;
  void *vp;
  int len;
  int i;
  char *cp;

  jclass clazz;
  jfieldID fid;

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

  /* ItronMemoryγϥɥ쥹롣*/
  vp=getAddr_jtc(env,obj_im);

  /* Ƭɥ쥹im_cp˥åȤ롣 */
  im_cp=(char *)vp;

  /* ItronMemoryĹ롣*/
  len=getMemLen_jtc(env,obj_im);
   
  /* إåʬ+ItronMemoryΰʬĹΰȤ롣*/
  cp=(char *)malloc(T_MSG_HEADBYTE+len);

  /* Ȥäΰ¤ΤΥɥ쥹ȤƥåȤ롣*/
  p_msg=(T_MSG *)cp;

  /* إåʬɥ쥹ưĤޤcpåΤƬˡ*/
  cp=cp+T_MSG_HEADBYTE;

  /* åΤItronMemoryΰ褫T_MSGΰcopy*/
  memcpy(cp,im_cp,len);

#ifdef JTRON_DEBUG
  /*  ɥ쥹ĹΤ߽ϡƤϥǡפ狼ʤ
     ϤǤʤΤ,֤ˤޤ롣*/
  printf("> snd_msg(a):im address=%x\n",vp);
  printf("> snd_msg(a):len=%d\n",len);
#endif

  /* ӥ */
  rv=snd_msg(mbxid,p_msg);

#ifdef JTRON_DEBUG
  printf("> snd_msg(a):rv=%d\n",rv);
#endif

  return (jint)rv;

}

/* trcv_msg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_trcv_1msg
(JNIEnv *env, jclass thisClass, jobject obj_im, jint mbxid, jint tmout)
{
  ER rv;
  T_MSG_JTN *pt_msg_jtn;
  VB *ad;
  jint ad_i;

  jclass clazz;
  jfieldID fid;  

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> trcv_msg(a):mbxid=%d\n",mbxid);
#endif

  /* ӥ */
  rv = trcv_msg((T_MSG**)&pt_msg_jtn,mbxid,tmout);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> trcv_msg(a):rv=%d\n",rv);
#endif

  /* åΤƬɥ쥹롣 */
  ad=(VB *)&((*pt_msg_jtn).msgcont[0]);

  /* ItronMemory˥ɥ쥹򥻥å */
  setAddr_jtc(env,obj_im,(void *)ad);

  /* ΰĹʤ*/
  // ΰ西פ
  setMemType_jtc(env,obj_im,MTYPE_ITRON_NOLEN);

#ifdef JTRON_DEBUG
  printf("> trcv_msg(a):address=%x\n",ad);
#endif
  
  return (jint)rv;
}

/* prcv_msg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_prcv_1msg
(JNIEnv *env, jclass thisClass, jobject obj_im, jint mbxid)
{
  ER rv;
  T_MSG_JTN *t_msg_jtn;
  VB *ad;
  jint ad_i;

  jclass clazz;
  jfieldID fid;  

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> prcv_msg(a):mbxid=%d\n",mbxid);
#endif

  /* ӥ */
  rv = prcv_msg((T_MSG**)&t_msg_jtn,mbxid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> prcv_msg(a):rv=%d\n",rv);
#endif

  /* åΤƬɥ쥹롣 */
  ad=(VB *)&((*t_msg_jtn).msgcont[0]);

  /* ItronMemory˥ɥ쥹򥻥å */
  setAddr_jtc(env,obj_im,(void *)ad);

  /* ΰĹʤ*/
  // ΰ西פ
  setMemType_jtc(env,obj_im,MTYPE_ITRON_NOLEN);

#ifdef JTRON_DEBUG
  printf("> prcv_msg(a):address=%x\n",ad);
#endif

  return (jint)rv;

}

/* rcv_msg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_rcv_1msg
(JNIEnv *env, jclass thisClass, jobject obj_im, jint mbxid) 
{
  ER rv;
  T_MSG_JTN *t_msg_jtn;
  VB *ad;
  jint ad_i;

  jclass clazz;
  jfieldID fid;  

  // ǡѥåȤΥå
  if( obj_im==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> rcv_msg(a):mbxid=%d\n",mbxid);
#endif

  /* ӥ */
  rv = rcv_msg((T_MSG**)&t_msg_jtn,mbxid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> rcv_msg(a):rv=%d\n",rv);
#endif

  /* åΤƬɥ쥹롣 */
  ad=(VB *)&((*t_msg_jtn).msgcont[0]);

  /* ItronMemory˥ɥ쥹򥻥å */
  setAddr_jtc(env,obj_im,(void *)ad);

  // ΰ西פ
  setMemType_jtc(env,obj_im,MTYPE_ITRON_NOLEN);

  /* ΰĹʤ*/

#ifdef JTRON_DEBUG
  printf("> rcv_msg(a):address=%x\n",ad);
#endif

  return (jint)rv;

}

/* del_mbx */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_del_1mbx
(JNIEnv *env, jclass thisClass, jint mbxid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> del_mbx(a):mbxid=%d\n",mbxid);
#endif

  /* ӥ */
  rv = del_mbx(mbxid);

#ifdef JTRON_DEBUG
  printf("> del_mbx(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* cre_mbx */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_cre_1mbx
(JNIEnv *env, jclass thisClass, jint mbxid, jobject obj_cmbx)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CMBX cmbx;

  // ǡѥåȤΥå
  if( obj_cmbx==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmbx);
  fid = env->GetFieldID(clazz,"mbxatr","I");
  cmbx.mbxatr = env->GetIntField(obj_cmbx,fid); 

  /*  bufcnt:󥰥Хåե礭BrightVǤʤ
  fid = env->GetFieldID(clazz,"bufcnt","I");
  cmbx.bufcnt = env->GetIntField(obj_cmbx,fid);
  */

#ifdef JTRON_DEBU
  printf("> cre_mbx(a):mbxid=%d\n",mbxid);
  printf("> cre_mbx(a):cmbx.mbxatr=%d\n",cmbx.mbxatr);
#endif

  /* ӥ */
  rv = cre_mbx(mbxid,&cmbx); 

#ifdef JTRON_DEBUG
  printf("> cre_mbx(a):rv=%d\n",rv);
#endif

  return (jint)rv;

}

/* vcre_mbx */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_vcre_1mbx
(JNIEnv *env, jclass thisClass, jobject obj_cmbx)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CMBX cmbx;

  // ǡѥåȤΥå
  if( obj_cmbx==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmbx);
  fid = env->GetFieldID(clazz,"mbxatr","I");
  cmbx.mbxatr = env->GetIntField(obj_cmbx,fid); 

  /*  bufcnt:󥰥Хåե礭BrightVǤʤ
  fid = env->GetFieldID(clazz,"bufcnt","I");
  cmbx.bufcnt = env->GetIntField(obj_cmbx,fid);
  */

#ifdef JTRON_DEBUG
  printf("> vcre_mbx(a):cmbx.mbxatr=%d\n",cmbx.mbxatr);
#endif
  
  /* ӥ */
  rv = vcre_mbx(&cmbx); 

#ifdef JTRON_DEBUG
  printf("> vcre_mbx(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}


/*
 *   饤٥ȥե饰ط
 */

/* ref_flg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_ref_1flg
(JNIEnv *env, jclass thisClass, jobject obj_rflg, jint flgid)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_RFLG rflg;

  // ǡѥåȤΥå
  if( obj_rflg==NULL) {
      return (jint)E_PAR; 
  }

  /* ӥ */
  rv = ref_flg(&rflg,flgid);
  if(rv<0) return (jint)rv;

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rflg);

  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rflg,fid,rflg.wtsk);
  
  fid = env->GetFieldID(clazz,"flgptn","I");
  env->SetIntField(obj_rflg,fid,rflg.flgptn);

  return (jint)rv;
}

/* twai_flg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_twai_1flg
(JNIEnv *env, jclass thisClass, jobject obj_flgptn, jint flgid, jint waiptn, jint wfmode,jint tmout)
{
  jclass clazz;
  jfieldID fid;

  UINT flgptn;
  ER rv;

  // ǡѥåȤΥå
  if( obj_flgptn==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> wai_flg(a):flgid=%d\n",flgid);
  printf("> wai_flg(a):waiptn=%d\n",waiptn);
  printf("> wai_flg(a):wfmode=%d\n",wfmode);
  printf("> wai_flg(a):tmout=%d\n",tmout);
#endif

  /* ӥ */
  rv = twai_flg(&flgptn,flgid,waiptn,wfmode,tmout);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> wai_flg(a):rv=%d\n",rv);
  printf("> wai_flg(a):flgptn=%d\n",flgptn);
#endif

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_flgptn);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_flgptn,fid,flgptn);

  return (jint)rv;
}

/* pol_flg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_pol_1flg
(JNIEnv *env, jclass thisClass, jobject obj_flgptn, jint flgid, jint waiptn, jint wfmode)
{
  jclass clazz;
  jfieldID fid;

  UINT flgptn;
  ER rv;

  // ǡѥåȤΥå
  if( obj_flgptn==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> wai_flg(a):flgid=%d\n",flgid);
  printf("> wai_flg(a):waiptn=%d\n",waiptn);
  printf("> wai_flg(a):wfmode=%d\n",wfmode);
#endif

  /* ӥ */
  rv = pol_flg(&flgptn,flgid,waiptn,wfmode);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> wai_flg(a):rv=%d\n",rv);
  printf("> wai_flg(a):flgptn=%d\n",flgptn);
#endif

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_flgptn);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_flgptn,fid,flgptn);

  return (jint)rv;
}

/* wai_flg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_wai_1flg
(JNIEnv *env, jclass thisClass, jobject obj_flgptn, jint flgid, jint waiptn, jint wfmode)
{
  jclass clazz;
  jfieldID fid;

  UINT flgptn;
  ER rv;

  // ǡѥåȤΥå
  if( obj_flgptn==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> wai_flg(a):flgid=%d\n",flgid);
  printf("> wai_flg(a):waiptn=%d\n",waiptn);
  printf("> wai_flg(a):wfmode=%d\n",wfmode);
#endif

  /* ӥ */
  rv = wai_flg(&flgptn,flgid,waiptn,wfmode);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> wai_flg(a):rv=%d\n",rv);
  printf("> wai_flg(a):flgptn=%d\n",flgptn);
#endif

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_flgptn);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj_flgptn,fid,flgptn);

  return (jint)rv;
}

/* clr_flg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_clr_1flg
(JNIEnv *env, jclass thisClass, jint flgid, jint clrptn)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> clr_flg(a):flgid=%d\n",flgid);
  printf("> clr_flg(a):clrptn=%d\n",clrptn);
#endif

  /* ӥ */
  rv = clr_flg(flgid,clrptn);

#ifdef JTRON_DEBUG
  printf("> clr_flg(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* set_flg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_set_1flg
(JNIEnv *env, jclass thisClass, jint flgid, jint setptn)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> set_flg(a):flgid=%d\n",flgid);
  printf("> set_flg(a):setptn=%d\n",setptn);
#endif

  /* ӥ */
  rv = set_flg(flgid,setptn);

#ifdef JTRON_DEBUG
  printf("> set_flg(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* del_flg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_del_1flg
(JNIEnv *env, jclass thisClass, jint flgid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> del_flg(a):flgid=%d\n",flgid);
#endif

  /* ӥ */
  rv = del_flg(flgid);

#ifdef JTRON_DEBUG
  printf("> del_flg(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* cre_flg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_cre_1flg
(JNIEnv *env, jclass thisClass, jint flgid, jobject obj_cflg)
{

  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CFLG cflg;

  // ǡѥåȤΥå
  if( obj_cflg==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cflg);
  fid = env->GetFieldID(clazz,"flgatr","I");
  cflg.flgatr = env->GetIntField(obj_cflg,fid); 
  fid = env->GetFieldID(clazz,"iflgptn","I");
  cflg.iflgptn = env->GetIntField(obj_cflg,fid); 

#ifdef JTRON_DEBUG
  printf("> vcre_flg(a):flgid=%d\n",flgid);
  printf("> vcre_flg(a):cflg.flgatr=%d\n",cflg.flgatr);
  printf("> vcre_flg(a):cflg.iflgptn=%d\n",cflg.iflgptn);
#endif

  /* ӥ */
  rv = cre_flg(flgid,&cflg);

#ifdef JTRON_DEBUG
  printf("> vcre_flg(a):rv=%d\n",rv);
#endif

  return (jint)rv;

}

/* vcre_flg */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_vcre_1flg
(JNIEnv *env, jclass thisClass, jobject obj_cflg)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CFLG cflg;

  // ǡѥåȤΥå
  if( obj_cflg==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cflg);
  fid = env->GetFieldID(clazz,"flgatr","I");
  cflg.flgatr = env->GetIntField(obj_cflg,fid); 
  fid = env->GetFieldID(clazz,"iflgptn","I");
  cflg.iflgptn = env->GetIntField(obj_cflg,fid); 

#ifdef JTRON_DEBUG
  printf("> vcre_flg(a):cflg.flgatr=%d\n",cflg.flgatr);
  printf("> vcre_flg(a):cflg.iflgptn=%d\n",cflg.iflgptn);
#endif

  /* ӥ */
  rv = vcre_flg(&cflg);

#ifdef JTRON_DEBUG
  printf("> vcre_flg(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/*
 *   饻ޥեط
 */

/* ref_sem */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_ref_1sem
(JNIEnv *env, jclass thisClass, jobject obj_rsem, jint semid)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_RSEM rsem; 

  // ǡѥåȤΥå
  if( obj_rsem==NULL) {
      return (jint)E_PAR; 
  }

  /* ӥ */
  rv = ref_sem(&rsem,semid);
  if(rv<0) return (jint)rv;

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rsem);

  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rsem,fid,rsem.wtsk);

  fid = env->GetFieldID(clazz,"semcnt","I");
  env->SetIntField(obj_rsem,fid,rsem.semcnt);

  return (jint)rv;
}

/* twai_sem */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_twai_1sem
(JNIEnv *env, jclass thisClass, jint semid, jint tmout)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> twai_sem(a):semid=%d\n",semid);
#endif

  /* ӥ */
  rv = twai_sem(semid,tmout);

#ifdef JTRON_DEBUG
  printf("> twai_sem(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* preq_sem */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_preq_1sem
(JNIEnv *env, jclass thisClass, jint semid) 
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> preq_sem(a):semid=%d\n",semid);
#endif

  /* ӥ */
  rv = preq_sem(semid);

#ifdef JTRON_DEBUG
  printf("> preq_sem(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* wai_sem */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_wai_1sem
(JNIEnv *env, jclass thisClass, jint semid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> wai_sem(a):semid=%d\n",semid);
#endif

  /* ӥ */
  rv = wai_sem(semid);

#ifdef JTRON_DEBUG
  printf("> wai_sem(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* sig_sem */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_sig_1sem
(JNIEnv *env, jclass thisClass, jint semid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> sig_sem(a):semid=%d\n",semid);
#endif

  /* ӥ */
  rv = sig_sem(semid);

#ifdef JTRON_DEBUG
  printf("> sig_sem(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* del_sem */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_del_1sem
(JNIEnv *env, jclass thisClass, jint semid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> del_sem(a):semid=%d\n",semid);
#endif

  /* ӥ */
  rv = del_sem(semid);

#ifdef JTRON_DEBUG
  printf("> del_sem(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* cre_sem */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_cre_1sem
(JNIEnv *env, jclass thisClass, jint semid, jobject obj_csem)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CSEM csem;

  // ǡѥåȤΥå
  if( obj_csem==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_csem);
  fid = env->GetFieldID(clazz,"sematr","I");
  csem.sematr = env->GetIntField(obj_csem,fid);
  
  fid = env->GetFieldID(clazz,"isemcnt","I");
  csem.isemcnt = env->GetIntField(obj_csem,fid);

  fid = env->GetFieldID(clazz,"maxsem","I");
  csem.maxsem = env->GetIntField(obj_csem,fid);

#ifdef JTRON_DEBUG
  printf("> cre_sem(a):csem.sematr=%d\n",csem.sematr);
  printf("> cre_sem(a):csem.isemcnt=%d\n",csem.isemcnt);
  printf("> cre_sem(a):csem.maxsem=%d\n",csem.maxsem);
#endif

  /* ӥ */
  rv = cre_sem(semid,&csem);

#ifdef JTRON_DEBUG
  printf("> cre_sem(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}


/* vcre_sem */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_vcre_1sem
(JNIEnv *env, jclass thisClass, jobject obj_csem)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_CSEM csem;

  // ǡѥåȤΥå
  if( obj_csem==NULL) {
      return (jint)E_PAR; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_csem);
  fid = env->GetFieldID(clazz,"sematr","I");
  csem.sematr = env->GetIntField(obj_csem,fid);
  
  fid = env->GetFieldID(clazz,"isemcnt","I");
  csem.isemcnt = env->GetIntField(obj_csem,fid);

  fid = env->GetFieldID(clazz,"maxsem","I");
  csem.maxsem = env->GetIntField(obj_csem,fid);

#ifdef JTRON_DEBUG
  printf("> vcre_sem(a):csem.sematr=%d\n",csem.sematr);
  printf("> vcre_sem(a):csem.isemcnt=%d\n",csem.isemcnt);
  printf("> vcre_sem(a):csem.maxsem=%d\n",csem.maxsem);
#endif
  
  /* ӥ */
  rv = vcre_sem(&csem);

#ifdef JTRON_DEBUG
  printf("> vcre_sem(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/*
 *   饿ط
 */

/* ref_tsk */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_ref_1tsk
(JNIEnv *env, jclass thisClass, jobject obj, jint tskid) 
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  T_RTSK rtsk;

#ifdef JTRON_DEBUG
  printf("> call ref_tsk()\n");
#endif


  // ǡѥåȤΥå
  if( obj==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall ref_tsk(&rtsk,tskid) tskid=%d\n",tskid);
#endif
  /* ӥ */
  rv = ref_tsk(&rtsk,tskid);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return ref_tsk(&rtsk,tskid)\n");
#endif

  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> rv=%d\n",rv);
  printf("> rtsk.tskpri=%d\n",rtsk.tskpri);
  printf("> rtsk.tskstat=%d\n",rtsk.tskstat);
  printf("> rtsk.tskwait=%d\n",rtsk.tskwait);
  printf("> rtsk.wid=%d\n",rtsk.wid);
  printf("> rtsk.wupcnt=%d\n",rtsk.wupcnt);
  printf("> rtsk.suscnt=%d\n",rtsk.suscnt);
#endif

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj);

  fid = env->GetFieldID(clazz,"tskpri","I");
  env->SetIntField(obj,fid,rtsk.tskpri);

  fid = env->GetFieldID(clazz,"tskstat","I");
  env->SetIntField(obj,fid,rtsk.tskstat);

  fid = env->GetFieldID(clazz,"tskwait","I");
  env->SetIntField(obj,fid,rtsk.tskwait);

  fid = env->GetFieldID(clazz,"wid","I");
  env->SetIntField(obj,fid,rtsk.wid);

  fid = env->GetFieldID(clazz,"wupcnt","I");
  env->SetIntField(obj,fid,rtsk.wupcnt);

  fid = env->GetFieldID(clazz,"suscnt","I");
  env->SetIntField(obj,fid,rtsk.suscnt);

  /* ʲBright/Vʤ */
  fid = env->GetFieldID(clazz,"tskatr","I");
  env->SetIntField(obj,fid,0);

  fid = env->GetFieldID(clazz,"itskpri","I");
  env->SetIntField(obj,fid,0);

  fid = env->GetFieldID(clazz,"stksz","I");
  env->SetIntField(obj,fid,0);

#ifdef JTRON_DEBUG
  printf("> call return ref_tsk()\n");
#endif

  return (jint)rv; 
}

/* can_wup */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_can_1wup
(JNIEnv *env, jclass thisClass, jobject obj, jint tskid)
{
  jclass clazz;
  jfieldID fid;

  ER rv;
  INT wupcnt;

  // ǡѥåȤΥå
  if( obj==NULL) {
      return (jint)E_PAR; 
  }

  /* ӥ */
  rv = can_wup(&wupcnt,tskid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> can_wup(a):rv=%d\n",rv);
  printf("> can_wup(a):wupcnt=%d\n",wupcnt);
#endif

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj);
  fid = env->GetFieldID(clazz,"value","I");
  env->SetIntField(obj,fid,wupcnt);

  return (jint)rv;
}


/* get_tid */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_get_1tid
(JNIEnv *env, jclass thisClass, jobject obj) {

  jclass clazz;
  jfieldID fid;

  ER rv;
  ID tskid;
  jint jtskid;

  // ǡѥåȤΥå
  if( obj==NULL) {
      return (jint)E_PAR; 
  }

  /* ӥ */
  rv = get_tid(&tskid);
  if(rv<0) return (jint)rv;

#ifdef JTRON_DEBUG
  printf("> get_tid(a):rv=%d\n",rv);
  printf("> get_tid(a):tskid=%d\n",tskid);
#endif

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj);
  fid = env->GetFieldID(clazz,"value","I");
  jtskid=(jint)tskid;
  env->SetIntField(obj,fid,jtskid);

  return (jint)rv;
 
}

/* wup_tsk */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_wup_1tsk
(JNIEnv *env, jclass thisObj, jint tskid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> wup_tsk(a):tskid=%d\n",tskid);
#endif

  /* ӥ */
  rv = wup_tsk(tskid);

#ifdef JTRON_DEBUG
  printf("> wup_tsk(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* tslp_tsk */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_tslp_1tsk
(JNIEnv *env, jclass thisClass, jint tmout)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> tslp_tsk(a):tmout=%d\n",tmout);
#endif
  
  /* ӥ */
  rv = tslp_tsk(tmout);

#ifdef JTRON_DEBUG
  printf("> tslp_tsk(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* slp_tsk */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_slp_1tsk
(JNIEnv *env, jclass thisClass) 
{
  ER rv;

  /* ӥ */
  rv = slp_tsk();

#ifdef JTRON_DEBUG
  printf("> slp_tsk(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* frsm_tsk */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_frsm_1tsk
(JNIEnv *env, jclass thisClass, jint tskid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> frsm_tsk(a):tskid=%d\n",tskid);
#endif

  /* ӥ */
  rv = frsm_tsk(tskid);

#ifdef JTRON_DEBUG
  printf("> frsm_tsk(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* rsm_tsk */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_rsm_1tsk
(JNIEnv *env, jclass thisClass, jint tskid) 
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> rsm_tsk(a):tskid=%d\n",tskid);
#endif
 
  /* ӥ */
  rv = rsm_tsk(tskid);

#ifdef JTRON_DEBUG
  printf("> rsm_tsk(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* sus_tsk */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_sus_1tsk
(JNIEnv *env, jclass thisClass, jint tskid)
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> sus_tsk(a):tskid=%d\n",tskid);
#endif
  
  /* ӥ */
  rv = sus_tsk(tskid);

#ifdef JTRON_DEBUG
  printf("> sus_tsk(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* rel_wai */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_rel_1wai
(JNIEnv *env, jclass thisClass, jint tskid) 
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> rel_wai(a):tskid=%d\n",tskid);
#endif
  
  /* ӥ */
  rv = rel_wai(tskid);

#ifdef JTRON_DEBUG
  printf("> rel_wai(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* rot_rdq */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_rot_1rdq
(JNIEnv *env, jclass thisClass, jint tskpri) 
{
  ER rv;

#ifdef JTRON_DEBUG
  printf("> rot_rdq(a):tskpri=%d\n",tskpri);
#endif
 
  /* ӥ */
  rv = rot_rdq(tskpri);

#ifdef JTRON_DEBUG
  printf("> rot_rdq(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* chg_pri */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_chg_1pri
(JNIEnv *env, jclass thisClass, jint tskid, jint tskpri) 
{

  ER rv;

#ifdef JTRON_DEBUG
  printf("> chg_pri(a):tskid=%d tskpri=%d\n",tskid,tskpri);
#endif

  /* ӥ */
  rv = chg_pri(tskid,tskpri);

#ifdef JTRON_DEBUG
  printf("> chg_pri(a):rv=%d\n",rv);
#endif

  return (jint)rv;

}


/* ena_dsp*/
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_ena_1dsp
(JNIEnv *env, jclass thisClass)
{
  ER rv;

  /* ӥ */
  rv = ena_dsp();

#ifdef JTRON_DEBUG
  printf("> ena_dsp(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* dis_dsp */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_dis_1dsp
(JNIEnv *env, jclass thisClass) 
{
  
  ER rv;

  /* ӥ */
  rv = dis_dsp();

#ifdef JTRON_DEBUG
  printf("> dis_dsp(a):rv=%d\n",rv);
#endif

  return (jint)rv;
}

/* set_tim */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_set_1tim
(JNIEnv *env, jclass thisClass, jlong time) 
{

  ER rv;

#ifdef JTRON_DEBUG
  printf("> set_tim(a):time=%d\n",time);
#endif

  /* ӥ */
  rv = set_tim(&time);

#ifdef JTRON_DEBUG
  printf("> set_tim(a):rv=%d\n",rv);
#endif

  return (jint)rv;

}

/* get_tim */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_ItronApi_get_1tim
(JNIEnv *env, jclass thisClass, jobject obj) {

  jclass clazz;
  jfieldID fid;

  ER rv;
  SYSTIME pk_tim;
  jlong l;

#ifdef JTRON_DEBUG
  printf("> call get_tim(l)\n");
#endif

  // ǡѥåȤΥå
  if( obj==NULL) {
      return (jint)E_PAR; 
  }

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall get_tim(&pk_tim)\n");
#endif
  /* ӥ */
  rv = get_tim(&pk_tim);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return get_tim(&pk_tim)\n");
  printf("> rv=%d\n",rv);
#endif

  if(rv<0) return (jint)rv;

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj);
  fid = env->GetFieldID(clazz,"value","J");
  l=pk_tim;
  env->SetLongField(obj,fid,l);

#ifdef JTRON_DEBUG
  printf("> call return get_tim(l)\n");
#endif

  return (jint)rv;

}

#ifdef __cplusplus
}
#endif
