/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: MailBox.cc
   Note: MailBox饹Υͥƥ֥᥽åɷ

   Version
    0.020     1999/10/1  λ꡼С
    0.030     1999/10/

*/

#include <jni.h>

/* JAVAHǺincludeե */
#ifdef JTRON_JAVAH
#include <jp_gr_itron_jtron_attach_MailBox.h>
#endif
#ifndef JTRON_JAVAH
#include <system_pkgs/jp_gr_itron_jtron_attach_MailBox.h>
#endif

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JIL */
/* #include <jil_std.h> */
/* JILεǽŪɬפǤϤʤΤbstdlibɤ*/ 

/* JTRON饹 */
#include <jti_common.h>
#include <jti_attach_common.h>

/* Linuxƥ */
#ifdef LINUXDEV
#include <stdlib.h>
#include <itronstub_extern.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
#include <bstdlib.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ᥤܥåå饹Υͥƥ֥᥽åɷ
 */

/* private native int mailbox_exist_jtn(int mbxId) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_MailBox_mailbox_1exist_1jtn
(JNIEnv *env, jobject thisObj, jint mbxid)
{
  ER err;

  T_RMBX rmbx;

#ifdef JTRON_DEBUG
  printf("> mailbox_exist_jtn(a):mbxid=%d\n",mbxid);
#endif

  // ꤵ줿IDΥ꥽뤫å롣
  err = ref_mbx(&rmbx,mbxid);

#ifdef JTRON_DEBUG
  printf("> mailbox_exist_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_MBX);
  }

  return (jint)err;
}

/* private native void mailbox_new_jtn(int mbxid,T_CMBX cmbx) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_MailBox_mailbox_1new_1jtn
(JNIEnv *env, jobject thisObj, jint mbxid, jobject obj_cmbx)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CMBX cmbx;

#ifdef JTRON_DEBUG
  printf("> call mailbox_new_jtn(int mbxid,T_CMBX cmbx) mbxid=%d\n",mbxid);
#endif

  // ǡѥåȤΥå
  if( obj_cmbx==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_CRE_MBX);
    return; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmbx);
  fid = env->GetFieldID(clazz,"mbxatr","I");
  cmbx.mbxatr = env->GetIntField(obj_cmbx,fid); 
  /*  bufcnt:󥰥Хåե礭BrightVǤʤ
  fid = env->GetFieldID(clazz,"bufcnt","I");
  cmbx.bufcnt = env->GetIntField(obj_cmbx,fid);
  */

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall cre_mbx(mbxid,&cmbx) mbxid=%d\n",mbxid);
  printf("> cmbx.mbxatr=%d\n",cmbx.mbxatr);
#endif
  /* ӥ */
  err = cre_mbx(mbxid,&cmbx);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return cre_mbx(mbxid,&cmbx)\n");
#endif


  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_CRE_MBX);
  }

#ifdef JTRON_DEBUG
  printf("> call return mailbox_new_jtn(int mbxid,T_CMBX cmbx)\n");
#endif

}

/* private native int mailbox_newa_jtn(T_CMBX cmbx) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_MailBox_mailbox_1newa_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_cmbx)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CMBX cmbx;

  // ǡѥåȤΥå
  if( obj_cmbx==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_VCRE_MBX);
    return 1; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmbx);
  fid = env->GetFieldID(clazz,"mbxatr","I");
  cmbx.mbxatr = env->GetIntField(obj_cmbx,fid); 
  /*  bufcnt:󥰥Хåե礭BrightVǤʤ
  fid = env->GetFieldID(clazz,"bufcnt","I");
  cmbx.bufcnt = env->GetIntField(obj_cmbx,fid);
  */

  /* ӥ */
  err = vcre_mbx(&cmbx);

#ifdef JTRON_DEBUG
  printf("> mailbox_newa_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_VCRE_MBX);
  }

  return (jint)err;
}

/* private native void delete_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_MailBox_delete_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err=del_mbx(id);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):id=%d\n",id);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_DEL_MBX);
  }
}

/*  private native void send_jtn(ItronMemory data) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_MailBox_send_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_im)
{
  ER err;
  T_MSG *p_msg;
  char *im_cp;
  jint ad_i;
  int len;
  int i;
  int *ip;
  char *cp;
  void *vp;

  jclass clazz;
  jfieldID fid;

  int id;

#ifdef JTRON_DEBUG
  printf("> call send_jtn(data)\n");
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* Ƭɥ쥹im_cp˥åȤ롣 */
  im_cp=(char *)getAddr_jtc(env,obj_im);

  /* ItronMemoryĹ롣*/
  len=getMemLen_jtc(env,obj_im);
   
  /* إåʬ+ItronMemoryΰʬĹΰȤ롣*/
  cp=(char *)malloc(T_MSG_HEADBYTE+len);

  /* Ȥäΰ¤ΤΥɥ쥹ȤƥåȤ롣*/
  p_msg=(T_MSG *)cp;

  /* إåʬɥ쥹ưĤޤcpåΤƬˡ*/
  cp=cp+T_MSG_HEADBYTE;

  /*
  ip=(int *)im_cp;
  for(i=0;i<3;i++) {
    printf("MBX send %d=%d add=%x\n",i,*(ip+i),(ip+i));
  }
  */

  /* åΤItronMemoryΰ褫T_MSGΰcopy*/
  memcpy(cp,im_cp,len);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall snd_msg(id,p_msg) id=%d\n",id);
  printf("> data address=%x\n",im_cp);
#endif
  /* ӥ */
  err=snd_msg(id,p_msg);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return snd_msg(id,p_msg)\n");
#endif


  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_SND_MSG);
  }

#ifdef JTRON_DEBUG
  printf("> call return send_jtn(data)\n");
#endif

}

/* private native void receive_jtn(ItronMemory im,int length) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_MailBox_receive_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_im, jint length, jint functype, jint tmout)
{
  ER err;
  T_MSG_JTN *t_msg_jtn;
  VB *ad;
  jint ad_i;

  jclass clazz;
  jfieldID fid;  

  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

////#ifdef JTRON_DEBUG
////  printf("> recieve_jtn(a):id=%d\n",id);
////  printf("> recieve_jtn(a):functype=%d\n",functype);
////#endif

  if( functype == FUNCTYPE_NORMAL ) {
    /* ӥ */
    err = rcv_msg((T_MSG**)&t_msg_jtn,id);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_RCV_MSG);
      return;
    }
  }

  if( functype == FUNCTYPE_TIMEOUT ) {

    /* ӥ */
    err = trcv_msg((T_MSG**)&t_msg_jtn,id,tmout);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_TRCV_MSG);
      return;
    }
  }

  if( functype == FUNCTYPE_POLL ) {
    /* ӥ */
    err = prcv_msg((T_MSG**)&t_msg_jtn,id);

    // 顼ä
    if( err < 0 ) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_PRCV_MSG);
      return;
    }
  }

#ifdef JTRON_DEBUG
  printf("> recieve_jtn(a):err=%d\n",err);
#endif

  /* åΤƬɥ쥹롣 */
  ad=(VB *)&((*t_msg_jtn).msgcont[0]);

  /* ItronMemory˥ɥ쥹򥻥å */
  setAddr_jtc(env,obj_im,(void *)ad);

  /* ItronMemoryΰĹ򥻥åȤ롣*/
  setMemLen_jtc(env,obj_im,length);

  /* ItronMemoryΰ西פꤹ롣*/
  setMemType_jtc(env,obj_im,MTYPE_ITRON);

}

/* private native int referstatus_jtn(T_RMBX rmbx) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_MailBox_referstatus_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_rmbx)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_RMBX rmbx;

  int id;

#ifdef JTRON_DEBUG
  printf("> call referstatus_jtn(rmbx)\n");
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall ref_mbx(&rmbx,id) id=%d\n",id);
#endif
  /* ӥ */
  err = ref_mbx(&rmbx,id);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return ref_mbx(&rmbx,id)\n");
  printf("> rmbx.wtsk=%d\n",rmbx.wtsk);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_MBX);
    return (jint)err;
  }

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rmbx);
  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rmbx,fid,rmbx.wtsk);

#ifdef JTRON_DEBUG
  printf("> call return referstatus_jtn(rmbx)\n");
  printf("> rmbx.wtsk=%d\n",rmbx.wtsk);
#endif

  return (jint)err;

}

#ifdef __cplusplus
}
#endif
