/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: Task.cc
   Note: Task饹Υͥƥ֥᥽åɷ

   Version
    0.020     1999/10/1  λ꡼С
    0.030     1999/10/

*/

#include <jni.h>

/* JAVAHǺincludeե */
#ifdef JTRON_JAVAH
#include <jp_gr_itron_jtron_attach_Task.h>
#endif
#ifndef JTRON_JAVAH
#include <system_pkgs/jp_gr_itron_jtron_attach_Task.h>
#endif

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JIL */
#ifndef LINUXDEV
#include <jil_std.h>
/* JILεǽŪɬס*/
#endif

/* JTRON饹 */
#include <jti_common.h>
#include <jti_attach_common.h>

/* Linuxƥ */
#ifdef LINUXDEV
#include <jil.h>
#include <stdlib.h>
#include <itronstub_extern.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
/* #include <bstdlib.h> */
/* jil_std򥤥󥯥롼ɤ롣*/
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  å饹Υͥƥ֥᥽åɷ
 */

/* Private native int task_existi_jtn(int taskId) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_Task_task_1existi_1jtn
(JNIEnv *env, jobject thisObj, jint taskid)
{

  ER err;

  T_RTSK rtsk;

#ifdef JTRON_DEBUG
  printf("> call task_existi_jtn(taskid) taskid=%d\n",taskid);
#endif

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall ref_tsk(&rtsk,taskid) taskid=%d\n",taskid);
#endif
  // ꤵ줿IDΥ꥽뤫å롣
  err = ref_tsk(&rtsk,taskid);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return ref_tsk(&rtsk,taskid)\n");
  printf("> rtsk.tskpri=%d\n",rtsk.tskpri);
  printf("> rtsk.tskstat=%d\n",rtsk.tskstat);
#endif


  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_TSK);
  }

#ifdef JTRON_DEBUG
  printf("> call return task_existi_jtn(taskid) err=%d\n",err);
#endif

  return (jint)err;

}

/* private native int task_existt_jtn(String threadname) */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_Task_task_1existt_1jtn
(JNIEnv *env, jobject thisObj, jstring jthrname)
{
  jint id;
  ER err;
  jboolean isCopy;
  int thrno;
  THR_MAP_TBL *thr_tbl;

  /* StringϤ줿å̾CǻȤʸѴ롣*/
  const char *thrname = env->GetStringUTFChars(jthrname,&isCopy);

#ifdef JTRON_DEBUG
  printf("> task_existt_jtn(a):thrname=%s\n",thrname);
#endif

  /* å̾饹åɼֹ롣*/
  err = jil_jti_get_thr((char *)thrname,&thrno);

#ifdef JTRON_DEBUG
  printf("> task_existt_jtn(a):err=%d\n",err);
  printf("> task_existt_jtn(a):thrno=%d\n",thrno);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,E_OBJ,-1);
    return 0;
  }

  /* åɼֹ椫饹åɥޥåԥ󥰥ơ֥*/
  thr_tbl=jil_get_thr_map_tbl(thrno);
  if( thr_tbl == NULL ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,E_OBJ,-1);
    return 0;
  }
  
  /* åɥޥåԥ󥰥ơ֥˥󤬽񤭹ޤƤʤ,
     ID-1λ롣λE_OBJ顼Ȥ롣
     åɤ줿run()äƤʤ֤Ǥ
     åɤȥΥޥåԥ󥰤бƤʤ
     åɥޥåԥ󥰥ơ֥˥åɾ󤷤񤭹ޤƤʤ
     Ͻ(tskid=-1)ΤޤޤȤʤäƤ롣1999/12/28
    */
  if( thr_tbl->tskid == -1 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,E_OBJ,-1);
    return 0;
  }

  /* ᤿ID֤*/
  return thr_tbl->tskid;
  
}

/* private native void start_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_start_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* ӥ */
  err=sta_tsk(id,0);

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_STA_TSK);
  }

}

/* private native void terminate_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_terminate_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* ӥ */
  err=ter_tsk(id);

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_TER_TSK);
  }
}

/* private native void changepriority_jtn(int priority) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_changepriority_1jtn
(JNIEnv *env, jobject thisObj, jint pri)
{
  ER err;
  int id;

#ifdef JTRON_DEBUG
  printf("> Call changepriority_jtn(priority) priority=%d\n",pri);
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall chg_pri(id,pri) id=%d priority=%d\n",id,pri);
#endif
  /* ӥ */
  err=chg_pri(id,pri);
#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return chg_pri(id,pri)\n");
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_CHG_PRI);
  }

#ifdef JTRON_DEBUG
  printf("> Call Return changepriority_jtn(priority)\n");
#endif

}

/* private native void releasewait_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_releasewait_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* ӥ */
  err=rel_wai(id);

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REL_WAI);
  }

}

/* private native void referstatus_jtn(T_RTSK rtsk) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_referstatus_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_rtsk)
{
  ER err;
  int id;
  T_RTSK rtsk;

  jclass clazz;
  jfieldID fid;

#ifdef JTRON_DEBUG
  printf("> call referstatus_jtn(rtsk)\n");
#endif

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall ref_tsk(&rtsk,id) id=%d\n",id);
#endif

  /*  ӥ */
  err = ref_tsk(&rtsk,id);

#ifdef JTRON_DEBUG
  printf("> ItronSystemCall Return ref_tsk(&rtsk,taskid)\n");
  printf("> rtsk.tskpri=%d\n",rtsk.tskpri);
  printf("> rtsk.tskstat=%d\n",rtsk.tskstat);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_TSK);
    return;
  }

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rtsk);
  fid = env->GetFieldID(clazz,"tskpri","I");
  env->SetIntField(obj_rtsk,fid,rtsk.tskpri);
  fid = env->GetFieldID(clazz,"tskstat","I");
  env->SetIntField(obj_rtsk,fid,rtsk.tskstat);
  fid = env->GetFieldID(clazz,"tskwait","I");
  env->SetIntField(obj_rtsk,fid,rtsk.tskwait);
  fid = env->GetFieldID(clazz,"wid","I");
  env->SetIntField(obj_rtsk,fid,rtsk.wid);
  fid = env->GetFieldID(clazz,"wupcnt","I");
  env->SetIntField(obj_rtsk,fid,rtsk.wupcnt);
  fid = env->GetFieldID(clazz,"suscnt","I");
  env->SetIntField(obj_rtsk,fid,rtsk.suscnt);

  /* ʲBright/Vʤ */
  fid = env->GetFieldID(clazz,"tskatr","I");
  env->SetIntField(obj_rtsk,fid,0);
  fid = env->GetFieldID(clazz,"itskpri","I");
  env->SetIntField(obj_rtsk,fid,0);
  fid = env->GetFieldID(clazz,"stksz","I");
  env->SetIntField(obj_rtsk,fid,0);
  
#ifdef JTRON_DEBUG
  printf("> call return referstatus_jtn(rtsk)\n");
#endif

}

/* private native void suspend_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_suspend_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* ӥ */
  err = sus_tsk(id);

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_SUS_TSK);
  }
  
}

/* private native void resume_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_resume_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* ӥ */
  err = rsm_tsk(id);

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_RSM_TSK);
  }
}

/* private native void forceresume_jtn */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_forceresume_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* ӥ */
  err = frsm_tsk(id);

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_FRSM_TSK);
  }
}

/* private native void sleep_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_sleep_1jtn__
(JNIEnv *env, jobject thisObj)
{
  ER err;

  /* ӥ */
  err = slp_tsk();

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_SLP_TSK);
  }
}

/* private native void sleep_jtn(int tmout) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_sleep_1jtn__I
(JNIEnv *env, jobject thisObj, jint tmout)
{
  ER err;

  /* ӥ */
  err = tslp_tsk(tmout);

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_TSLP_TSK);
  }
}

/* private native void wakeup_jtn() */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_wakeup_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* ӥ */
  err = wup_tsk(id);

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_WUP_TSK);
  }
}

/* private native int cancelwakeup_jtn() */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_Task_cancelwakeup_1jtn
(JNIEnv *env, jobject thisObj)
{
  INT wupcnt;
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

  /* ӥ */
  err = can_wup(&wupcnt,id);

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_CAN_WUP);
  }

  return (jint)wupcnt;
}

/*private native static void rotatereadyqueue_jtn(int priority) */
JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_Task_rotatereadyqueue_1jtn
(JNIEnv *env, jclass thisClass, jint pri,jobject obj_ab)
{

  ER err;

  /* ӥ */
  err = rot_rdq(pri);

  /* staticΥ顼 */
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,obj_ab,err,TFN_ROT_RDQ);
  }

}

/* private static native int gettaskid_jtn() */
JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_Task_gettaskid_1jtn
(JNIEnv *env, jclass thisClass, jobject obj_ab)
{  
  ER err;

  ID taskid;

  /* ӥ */
  err = get_tid(&taskid);

  /* staticΥ顼 */
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,obj_ab,err,TFN_GET_TID);
  }

  return (jint)taskid;
}

#ifdef __cplusplus
}
#endif
