/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: VariableMemoryPool.cc
   Note: VariableMemoryPool饹Υͥƥ֥᥽åɷ

   Version
    0.020     1999/10/1  λ꡼С
    0.030     1999/10/

*/

#include <jni.h>

/* JAVAHǺincludeե */
#ifdef JTRON_JAVAH
#include <jp_gr_itron_jtron_attach_VariableMemoryPool.h>
#endif
#ifndef JTRON_JAVAH
#include <system_pkgs/jp_gr_itron_jtron_attach_VariableMemoryPool.h>
#endif

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JIL */
/* #include <jil_std.h> */
/* JILεǽŪɬפǤϤʤΤbstdlibɤ*/ 

/* JTRON饹 */
#include <jti_common.h>
#include <jti_attach_common.h>

/* Linuxƥ */
#ifdef LINUXDEV
#include <stdlib.h>
#include <itronstub_extern.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
#include <bstdlib.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif


/*
 *  Ĺס륢å饹Υͥƥ֥᥽åɷ
 */

JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_VariableMemoryPool_variablememorypool_1exist_1jtn
(JNIEnv *env, jobject thisObj, jint mplid)
{
  ER err;

  T_RMPL rmpl;

#ifdef JTRON_DEBUG
  printf("> variablememorypool_exist_jtn(a):mplid=%d\n",mplid);
#endif

  // ꤵ줿IDΥ꥽뤫å롣
  err = ref_mpl(&rmpl,mplid);

#ifdef JTRON_DEBUG
  printf("> variablememorypool_exist_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_MPL);
  }

}

JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_VariableMemoryPool_variablememorypool_1new_1jtn
(JNIEnv *env, jobject thisObj, jint mplid, jobject obj_cmpl)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CMPL cmpl;

  // ǡѥåȤΥå
  if( obj_cmpl==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_CRE_MPL);
    return; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmpl);
  fid = env->GetFieldID(clazz,"mplatr","I");
  cmpl.mplatr = env->GetIntField(obj_cmpl,fid);
  fid = env->GetFieldID(clazz,"mplsz","I");
  cmpl.mplsz = env->GetIntField(obj_cmpl,fid);

#ifdef JTRON_DEBUG
  printf("> variablememorypool_new_jtn(a):mplid=%d\n",mplid);
#endif

  /* ӥ */
  err = cre_mpl(mplid,&cmpl); 

#ifdef JTRON_DEBUG
  printf("> variablememorypool_new_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_CRE_MPL);
  }
 
}

JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_VariableMemoryPool_get_1jtn
(JNIEnv *env, jobject thisObj, jint len, jobject obj_im, jint functype, jint tmout)
{
  ER err;
  void *vp;
  int id;
  
  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> get_jtn(a):id=%d\n",id);
  printf("> get_jtn(a):functype=%d\n",functype);
#endif

  if(functype == FUNCTYPE_NORMAL ) {
    /* ӥ */
    err=get_blk(&vp,id,len);
    if(err<0) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_GET_BLK);
      return;
    }
  }
  if(functype == FUNCTYPE_TIMEOUT ) {
    /* ӥ */
    err=tget_blk(&vp,id,len,tmout);
    if(err<0) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_TGET_BLK);
      return;
    }
  }
  if(functype == FUNCTYPE_POLL ) {
    /* ӥ */
    err=pget_blk(&vp,id,len);
    if(err<0) {
      // 顼ξܺٲڤJavaإ顼Ϥ
      setErrInf2Obj_jtc(env,thisObj,err,TFN_PGET_BLK);
      return;
    }
  }

#ifdef JTRON_DEBUG
  printf("> get_jtn(a):err=%d\n",err);
#endif

  /* ΰξItronMemory˥å */
  setAddr_jtc(env,obj_im,vp);
  /* ΰĹItronMemory˥å */
  setMemLen_jtc(env,obj_im,len);
  /* ΰ西פΥå */
  setMemType_jtc(env,obj_im,MTYPE_MEMPOOL);
  
}

JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_attach_VariableMemoryPool_variablememorypool_1newa_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_cmpl)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_CMPL cmpl;

  // ǡѥåȤΥå
  if( obj_cmpl==NULL) {
    setErrInf2Obj_jtc(env,thisObj,E_PAR,TFN_CRE_MPL);
    return 0; 
  }

  /* (ӥΥѥ᡼Ȥʤ)ǡѥåȤκ */
  clazz = env->GetObjectClass(obj_cmpl);
  fid = env->GetFieldID(clazz,"mplatr","I");
  cmpl.mplatr = env->GetIntField(obj_cmpl,fid);
  fid = env->GetFieldID(clazz,"mplsz","I");
  cmpl.mplsz = env->GetIntField(obj_cmpl,fid);

  /* ӥ */
  err = vcre_mpl(&cmpl); 

#ifdef JTRON_DEBUG
  printf("> variablememorypool_newa_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_VCRE_MPL);
  }
 
  return (jint)err;
}

JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_VariableMemoryPool_referstatus_1jtn
(JNIEnv *env, jobject thisObj, jobject obj_rmpl)
{
  jclass clazz;
  jfieldID fid;

  ER err;
  T_RMPL rmpl; 
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> referstatus_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err = ref_mpl(&rmpl,id);

#ifdef JTRON_DEBUG
  printf("> referstatus_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_REF_MPL);
    return;
  }

  /* obj˥ӥΥ꥿ѥ᡼(rvʳ)򥻥å */
  clazz = env->GetObjectClass(obj_rmpl);
  fid = env->GetFieldID(clazz,"wtsk","I");
  env->SetIntField(obj_rmpl,fid,rmpl.wtsk);
  fid = env->GetFieldID(clazz,"frsz","I");
  env->SetIntField(obj_rmpl,fid,rmpl.frsz);
  fid = env->GetFieldID(clazz,"maxsz","I");
  env->SetIntField(obj_rmpl,fid,rmpl.maxsz);

}

JNIEXPORT void JNICALL Java_jp_gr_itron_jtron_attach_VariableMemoryPool_delete_1jtn
(JNIEnv *env, jobject thisObj)
{
  ER err;
  int id;

  /* ID롣 */
  id=getId_jtc(env,thisObj);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):id=%d\n",id);
#endif

  /* ӥ */
  err = del_mpl(id);

#ifdef JTRON_DEBUG
  printf("> delete_jtn(a):err=%d\n",err);
#endif

  // 顼ä
  if( err < 0 ) {
    // 顼ξܺٲڤJavaإ顼Ϥ
    setErrInf2Obj_jtc(env,thisObj,err,TFN_DEL_MPL);
    return;
  }
}

#ifdef __cplusplus
}
#endif

