/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: jti_attach_common.cc
   Note: å饹̥롼

   Version
    0.020     1999/10/1  λ꡼С
    0.030     1999/10/

*/

#include <jni.h>

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JTRON饹 */
#include <jti_common.h>
#include <jti_attach_common.h>

/* Linuxƥ */
#ifdef LINUXDEV
#include <stdio.h>
#include <stdlib.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
#include <bstdlib.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif


/*
  󥹥󥹤ꤵƤID,꥿󤹤롣
 */
int getId_jtc(JNIEnv *env, jobject thisObj) {

  jint val;

  jclass clazz = env->GetObjectClass(thisObj);
  jfieldID fid = env->GetFieldID(clazz,"Id","I");
  val = env->GetIntField(thisObj,fid);

  return val;

}

/*
  ItronMemoryΰ西פꤹ롣
 */
void setMemType_jtc(JNIEnv *env, jobject thisObj,int type) {

  jclass clazz;
  jfieldID fid;

////#ifdef JTRON_DEBUG
////  printf("? setMemType_jtc(a):type=%d\n",type);
////#endif
 
  clazz = env->GetObjectClass(thisObj);
  fid = env->GetFieldID(clazz,"type","I");
  env->SetIntField(thisObj,fid,type);  

}

/*
  ItronMemoryΰĹͤꤹ롣
 */
void setMemLen_jtc(JNIEnv *env, jobject thisObj,int len) {

  jclass clazz;
  jfieldID fid;
  
////#ifdef JTRON_DEBUG
////  printf("? setMemLen_jtc(a):len=%d\n",len);
////#endif

  clazz = env->GetObjectClass(thisObj);
  fid = env->GetFieldID(clazz,"length","I");
  env->SetIntField(thisObj,fid,len);  

}

/*
  ΰĹ롣
 */
int getMemLen_jtc(JNIEnv *env, jobject thisObj) {

  jint val;

  jclass clazz = env->GetObjectClass(thisObj);
  jfieldID fid = env->GetFieldID(clazz,"length","I");
  val = env->GetIntField(thisObj,fid);

#ifdef JTRON_DEBUG
  printf("? getMemLen_jtc(a):len=%d\n",val);
#endif

  return val;

}

/*
  ɥ쥹ItronMemoryΥ󥹥󥹤ꤹ롣
 */
void setAddr_jtc(JNIEnv *env, jobject thisObj,void *vp) {

  jclass clazz;
  jfieldID fid;

  clazz = env->GetObjectClass(thisObj);
  fid = env->GetFieldID(clazz,"startAddress","I");
  env->SetIntField(thisObj,fid,(jint)vp);  

////#ifdef JTRON_DEBUG
////  printf("? setAddr_jtc(a):address=%x\n",vp);
////#endif

  /* ɥ쥹ꤷ,offset0᤹*/
  fid = env->GetFieldID(clazz,"accessPoint","I");
  env->SetIntField(thisObj,fid,(jint)0);  
}

/*
  ItronMemoryΥ󥹥󥹤ꤵƤ륢ɥ쥹ƥ꥿󤹤롣
 */
void *getAddr_jtc(JNIEnv *env, jobject thisObj) {

  jint val;

  jclass clazz = env->GetObjectClass(thisObj);
  jfieldID fid = env->GetFieldID(clazz,"startAddress","I");
  val = env->GetIntField(thisObj,fid);

#ifdef JTRON_DEBUG
  printf("? getAddr_jtc(a):address=%x\n",val);
#endif

  return (void *)val;

}


/* 
 顼

 err   顼      (ɤʥ顼?)
 fncd  ǽ  (ɤΥƥॳƤӽФݤ˥顼?)

 򸵤˾ܺپJava֥Ȥ֤
 ֤֥(ǡΰ) JNIEnv *env, jobject thisObj Ȥ롣
*/
void setErrInf2Obj_jtc(JNIEnv *env, jobject thisObj,ER err,FN fncd) {

  jclass thisClass;
  jfieldID fid;
  char *apiname;
  jstring japiname;
  jobject japiobj;

  char *errorname;
  jstring jerrorname;

  int fncdm,fncdc;

  thisClass = env->GetObjectClass(thisObj);

  /* 顼 */
  fid = env->GetFieldID(thisClass,"ErrorCode","I");
  env->SetIntField(thisObj,fid,err);

  /* 顼  饹           ꤷʤ*/
  /* 顼  ᥸㡼ֹ     ꤷʤ*/  
  /*
   PMCΥץץäƤ票顼ɼФޥ
   ѥ1
   #define toERR(er)       (er >> 16)   
   ѥ2
   #define toERR(class,detail) ((ERR)((class)<<16|(UH)(detail)))

   toERR(EC_INNER,err);
   */

  /* 顼ɤ饨顼̾롣 */
  errorname= err2ername_jtc(err);
  /* ǽ̾ */
  fid = env->GetFieldID(thisClass,"ErrorName","Ljava/lang/String;");
  jerrorname=env->NewStringUTF(errorname);
  env->SetObjectField(thisObj,fid,jerrorname);

  /* ǽ */
  fncdm=FNCD2MFNCD(fncd);
  fid = env->GetFieldID(thisClass,"ApiNo","I");
  env->SetIntField(thisObj,fid,fncdm);

  fncdc=FNCD2CFNCD(fncd);
  fid = env->GetFieldID(thisClass,"ApiCls","I");
  env->SetIntField(thisObj,fid,fncdc);

  /* ǽɤ鵡ǽ̾롣 */
  apiname= fncd2fnname_jtc(fncd);
  /* ǽ̾ */
  fid = env->GetFieldID(thisClass,"ApiName","Ljava/lang/String;");
  /*
    String,ܥפǤϤʤ֥ȡ
    äƥNewStringUTFϥ֥ؿ˳롣

    ѹ㤨аʲ
      1.charǼ?
      2.String֤Native᥽åɤѰդ롣
   */
  japiname=env->NewStringUTF(apiname);
  env->SetObjectField(thisObj,fid,japiname);

}

/*
   ǽɤǽ̾Ѵ롣
     (VerX.XXX/itronstub/work/makeErcd2name.plǺ)
 */
char *err2ername_jtc(ER err) {
  char *name;

  name=NULL;

  if( err == E_OK ) {
    name="ITRON ERROR:OK"; /*  ｪλ  */
  } 
  if( err == E_SYS ) {
    name="ITRON ERROR:SYS"; /*  ƥ२顼  */
  } 
  if( err == E_NOMEM ) {
    name="ITRON ERROR:NOMEM"; /*  ­  */
  } 
  if( err == E_NOSPT ) {
    name="ITRON ERROR:NOSPT"; /*  ̤ݡȵǽ  */
  } 
  if( err == E_INOSPT ) {
    name="ITRON ERROR:INOSPT"; /*  ITRON/FILE Ǥ̤ݡȵǽ  */
  } 
  if( err == E_RSFN ) {
    name="ITRON ERROR:RSFN"; /*  ͽǽֹ  */
  } 
  if( err == E_RSATR ) {
    name="ITRON ERROR:RSATR"; /*  ͽ°  */
  } 
  if( err == E_PAR ) {
    name="ITRON ERROR:PAR"; /*  ѥ᥿顼  */
  } 
  if( err == E_ID ) {
    name="ITRON ERROR:ID"; /*  IDֹ  */
  } 
  if( err == E_NOEXS ) {
    name="ITRON ERROR:NOEXS"; /*  ֥Ȥ¸ߤƤʤ  */
  } 
  if( err == E_OBJ ) {
    name="ITRON ERROR:OBJ"; /*  ֥Ȥξ֤  */
  } 
  if( err == E_MACV ) {
    name="ITRON ERROR:MACV"; /*  ꥢǽ/ȿ  */
  } 
  if( err == E_OACV ) {
    name="ITRON ERROR:OACV"; /*  ֥ȥȿ  */
  } 
  if( err == E_CTX ) {
    name="ITRON ERROR:CTX"; /*  ƥȥ顼  */
  } 
  if( err == E_QOVR ) {
    name="ITRON ERROR:QOVR"; /*  塼󥰤ΥСե  */
  } 
  if( err == E_DLT ) {
    name="ITRON ERROR:DLT"; /*  Ԥ֥Ȥ줿  */
  } 
  if( err == E_TMOUT ) {
    name="ITRON ERROR:TMOUT"; /*  ݡ󥰼/ॢ  */
  } 
  if( err == E_RLWAI ) {
    name="ITRON ERROR:RLWAI"; /*  Ԥֶ  */
  } 

  /* ꤵʤä */
  if( name == NULL) {
    name="ITRON ERROR:?";
  }

  return name;

}
/*
   ǽɤǽ̾Ѵ롣
     (VerX.XXX/itronstub/work/makefncd2name.plǺ)
 */
char *fncd2fnname_jtc(FN fncd) {

  char *name;

  name=NULL;

  if( fncd == TFN_UNL_CPU ) {
    name="UNL_CPU"; 
  } 
  if( fncd == TFN_LOC_CPU ) {
    name="LOC_CPU"; 
  } 
  if( fncd == TFN_DEF_SVC ) {
    name="DEF_SVC"; 
  } 
  if( fncd == TFN_REF_SYS ) {
    name="REF_SYS"; 
  } 
  if( fncd == TFN_REF_CFG ) {
    name="REF_CFG"; 
  } 
  if( fncd == TFN_GET_VER ) {
    name="GET_VER"; 
  } 
  if( fncd == TFN_CRE_TSK ) {
    name="CRE_TSK"; 
  } 
  if( fncd == TFN_DEL_TSK ) {
    name="DEL_TSK"; 
  } 
  if( fncd == TFN_REF_TSK ) {
    name="REF_TSK"; 
  } 
  if( fncd == TFN_EXT_TSK ) {
    name="EXT_TSK"; 
  } 
  if( fncd == TFN_EXD_TSK ) {
    name="EXD_TSK"; 
  } 
  if( fncd == TFN_STA_TSK ) {
    name="STA_TSK"; 
  } 
  if( fncd == TFN_GET_TID ) {
    name="GET_TID"; 
  } 
  if( fncd == TFN_TER_TSK ) {
    name="TER_TSK"; 
  } 
  if( fncd == TFN_CHG_PRI ) {
    name="CHG_PRI"; 
  } 
  if( fncd == TFN_ROT_RDQ ) {
    name="ROT_RDQ"; 
  } 
  if( fncd == TFN_ENA_DSP ) {
    name="ENA_DSP"; 
  } 
  if( fncd == TFN_DIS_DSP ) {
    name="DIS_DSP"; 
  } 
  if( fncd == TFN_REL_WAI ) {
    name="REL_WAI"; 
  } 
  if( fncd == TFN_SUS_TSK ) {
    name="SUS_TSK"; 
  } 
  if( fncd == TFN_RSM_TSK ) {
    name="RSM_TSK"; 
  } 
  if( fncd == TFN_FRSM_TSK ) {
    name="FRSM_TSK"; 
  } 
  if( fncd == TFN_TSLP_TSK ) {
    name="TSLP_TSK"; 
  } 
  if( fncd == TFN_SLP_TSK ) {
    name="SLP_TSK"; 
  } 
  if( fncd == TFN_WUP_TSK ) {
    name="WUP_TSK"; 
  } 
  if( fncd == TFN_CAN_WUP ) {
    name="CAN_WUP"; 
  } 
  if( fncd == TFN_CRE_FLG ) {
    name="CRE_FLG"; 
  } 
  if( fncd == TFN_DEL_FLG ) {
    name="DEL_FLG"; 
  } 
  if( fncd == TFN_REF_FLG ) {
    name="REF_FLG"; 
  } 
  if( fncd == TFN_WAI_FLG ) {
    name="WAI_FLG"; 
  } 
  if( fncd == TFN_CLR_FLG ) {
    name="CLR_FLG"; 
  } 
  if( fncd == TFN_SET_FLG ) {
    name="SET_FLG"; 
  } 
  if( fncd == TFN_CRE_SEM ) {
    name="CRE_SEM"; 
  } 
  if( fncd == TFN_DEL_SEM ) {
    name="DEL_SEM"; 
  } 
  if( fncd == TFN_REF_SEM ) {
    name="REF_SEM"; 
  } 
  if( fncd == TFN_WAI_SEM ) {
    name="WAI_SEM"; 
  } 
  if( fncd == TFN_SIG_SEM ) {
    name="SIG_SEM"; 
  } 
  if( fncd == TFN_CRE_MBX ) {
    name="CRE_MBX"; 
  } 
  if( fncd == TFN_DEL_MBX ) {
    name="DEL_MBX"; 
  } 
  if( fncd == TFN_REF_MBX ) {
    name="REF_MBX"; 
  } 
  if( fncd == TFN_RCV_MSG ) {
    name="RCV_MSG"; 
  } 
  if( fncd == TFN_SND_MSG ) {
    name="SND_MSG"; 
  } 
  if( fncd == TFN_DEF_INT ) {
    name="DEF_INT"; 
  } 
  if( fncd == TFN_CHG_IMS ) {
    name="CHG_IMS"; 
  } 
  if( fncd == TFN_REF_IMS ) {
    name="REF_IMS"; 
  } 
  if( fncd == TFN_CRE_MPF ) {
    name="CRE_MPF"; 
  } 
  if( fncd == TFN_DEL_MPF ) {
    name="DEL_MPF"; 
  } 
  if( fncd == TFN_REF_MPF ) {
    name="REF_MPF"; 
  } 
  if( fncd == TFN_GET_BLF ) {
    name="GET_BLF"; 
  } 
  if( fncd == TFN_REL_BLF ) {
    name="REL_BLF"; 
  } 
  if( fncd == TFN_VGET_TIM ) {
    name="VGET_TIM"; 
  } 
  if( fncd == TFN_SET_TIM ) {
    name="SET_TIM"; 
  } 
  if( fncd == TFN_GET_TIM ) {
    name="GET_TIM"; 
  } 
  if( fncd == TFN_DLY_TSK ) {
    name="DLY_TSK"; 
  } 
  if( fncd == TFN_DEF_ALM ) {
    name="DEF_ALM"; 
  } 
  if( fncd == TFN_DEF_CYC ) {
    name="DEF_CYC"; 
  } 
  if( fncd == TFN_REF_ALM ) {
    name="REF_ALM"; 
  } 
  if( fncd == TFN_REF_CYC ) {
    name="REF_CYC"; 
  } 
  if( fncd == TFN_ACT_CYC ) {
    name="ACT_CYC"; 
  } 
  if( fncd == TFN_NGET_NOD ) {
    name="NGET_NOD"; 
  } 
  if( fncd == TFN_NGET_VER ) {
    name="NGET_VER"; 
  } 
  if( fncd == TFN_NREA_DAT ) {
    name="NREA_DAT"; 
  } 
  if( fncd == TFN_NWRI_DAT ) {
    name="NWRI_DAT"; 
  } 
  if( fncd == TFN_PGET_BLF ) {
    name="PGET_BLF"; 
  } 
  if( fncd == TFN_PGET_BLK ) {
    name="PGET_BLK"; 
  } 
  if( fncd == TFN_POL_FLG ) {
    name="POL_FLG"; 
  } 
  if( fncd == TFN_PREQ_SEM ) {
    name="PREQ_SEM"; 
  } 
  if( fncd == TFN_PRCV_MSG ) {
    name="PRCV_MSG"; 
  } 
  if( fncd == TFN_PSND_MBF ) {
    name="PSND_MBF"; 
  } 
  if( fncd == TFN_PRCV_MBF ) {
    name="PRCV_MBF"; 
  } 
  if( fncd == TFN_PCAL_POR ) {
    name="PCAL_POR"; 
  } 
  if( fncd == TFN_PACP_POR ) {
    name="PACP_POR"; 
  } 
  if( fncd == TFN_CRE_MPL ) {
    name="CRE_MPL"; 
  } 
  if( fncd == TFN_DEL_MPL ) {
    name="DEL_MPL"; 
  } 
  if( fncd == TFN_REF_MPL ) {
    name="REF_MPL"; 
  } 
  if( fncd == TFN_GET_BLK ) {
    name="GET_BLK"; 
  } 
  if( fncd == TFN_REL_BLK ) {
    name="REL_BLK"; 
  } 
  if( fncd == TFN_CRE_POR ) {
    name="CRE_POR"; 
  } 
  if( fncd == TFN_DEL_POR ) {
    name="DEL_POR"; 
  } 
  if( fncd == TFN_REF_POR ) {
    name="REF_POR"; 
  } 
  if( fncd == TFN_CAL_POR ) {
    name="CAL_POR"; 
  } 
  if( fncd == TFN_ACP_POR ) {
    name="ACP_POR"; 
  } 
  if( fncd == TFN_RPL_RDV ) {
    name="RPL_RDV"; 
  } 
  if( fncd == TFN_FWD_POR ) {
    name="FWD_POR"; 
  } 
  if( fncd == TFN_CRE_MBF ) {
    name="CRE_MBF"; 
  } 
  if( fncd == TFN_DEL_MBF ) {
    name="DEL_MBF"; 
  } 
  if( fncd == TFN_REF_MBF ) {
    name="REF_MBF"; 
  } 
  if( fncd == TFN_SND_MBF ) {
    name="SND_MBF"; 
  } 
  if( fncd == TFN_RCV_MBF ) {
    name="RCV_MBF"; 
  } 
  if( fncd == TFN_TGET_BLF ) {
    name="TGET_BLF"; 
  } 
  if( fncd == TFN_TGET_BLK ) {
    name="TGET_BLK"; 
  } 
  if( fncd == TFN_TWAI_FLG ) {
    name="TWAI_FLG"; 
  } 
  if( fncd == TFN_TWAI_SEM ) {
    name="TWAI_SEM"; 
  } 
  if( fncd == TFN_TRCV_MSG ) {
    name="TRCV_MSG"; 
  } 
  if( fncd == TFN_TSND_MBF ) {
    name="TSND_MBF"; 
  } 
  if( fncd == TFN_TRCV_MBF ) {
    name="TRCV_MBF"; 
  } 
  if( fncd == TFN_TCAL_POR ) {
    name="TCAL_POR"; 
  } 
  if( fncd == TFN_TACP_POR ) {
    name="TACP_POR"; 
  } 
  if( fncd == TFN_VSET_REG ) {
    name="VSET_REG"; 
  } 
  if( fncd == TFN_VGET_REG ) {
    name="VGET_REG"; 
  } 
  if( fncd == TFN_VSET_POW ) {
    name="VSET_POW"; 
  } 
  if( fncd == TFN_VEND_EXC ) {
    name="VEND_EXC"; 
  } 
  if( fncd == TFN_VDIS_FEX ) {
    name="VDIS_FEX"; 
  } 
  if( fncd == TFN_VENA_FEX ) {
    name="VENA_FEX"; 
  } 
  if( fncd == TFN_VRAS_FEX ) {
    name="VRAS_FEX"; 
  } 
  if( fncd == TFN_VDEF_FEX ) {
    name="VDEF_FEX"; 
  } 
  if( fncd == TFN_VDEF_BRK ) {
    name="VDEF_BRK"; 
  } 
  if( fncd == TFN_VCHG_SLT ) {
    name="VCHG_SLT"; 
  } 
  if( fncd == TFN_VINF_TSK ) {
    name="VINF_TSK"; 
  } 
  if( fncd == TFN_VDIS_WAI ) {
    name="VDIS_WAI"; 
  } 
  if( fncd == TFN_VENA_WAI ) {
    name="VENA_WAI"; 
  } 
  if( fncd == TFN_VSET_TEV ) {
    name="VSET_TEV"; 
  } 
  if( fncd == TFN_VWAI_TEV ) {
    name="VWAI_TEV"; 
  } 
  if( fncd == TFN_VEIF_TSK ) {
    name="VEIF_TSK"; 
  } 
  if( fncd == TFN_VCRE_TSK ) {
    name="VCRE_TSK"; 
  } 
  if( fncd == TFN_VCRE_SEM ) {
    name="VCRE_SEM"; 
  } 
  if( fncd == TFN_VCRE_FLG ) {
    name="VCRE_FLG"; 
  } 
  if( fncd == TFN_VCRE_MBX ) {
    name="VCRE_MBX"; 
  } 
  if( fncd == TFN_VCRE_MBF ) {
    name="VCRE_MBF"; 
  } 
  if( fncd == TFN_VCRE_POR ) {
    name="VCRE_POR"; 
  } 
  if( fncd == TFN_VCRE_MPL ) {
    name="VCRE_MPL"; 
  } 
  if( fncd == TFN_VCRE_MPF ) {
    name="VCRE_MPF"; 
  } 
  if( fncd == TFN_VPGET_BKS ) {
    name="VPGET_BKS"; 
  } 
  if( fncd == TFN_VREL_BKS ) {
    name="VREL_BKS"; 
  } 
  if( fncd == TFN_VATR_BKS ) {
    name="VATR_BKS"; 
  } 
  if( fncd == TFN_VREF_BKS ) {
    name="VREF_BKS"; 
  } 
  if( fncd == TFN_VREF_SVC ) {
    name="VREF_SVC"; 
  } 
  if( fncd == TFN_VGET_OTM ) {
    name="VGET_OTM"; 
  } 
  if( fncd == TFN_VDEF_CYC ) {
    name="VDEF_CYC"; 
  } 
  if( fncd == TFN_VDEF_ALM ) {
    name="VDEF_ALM"; 
  } 
  if( fncd == TFN_VCRE_PIS ) {
    name="VCRE_PIS"; 
  } 
  if( fncd == TFN_VDEL_PIS ) {
    name="VDEL_PIS"; 
  } 
  if( fncd == TFN_VVCRE_PIS ) {
    name="VVCRE_PIS"; 
  } 
  if( fncd == TFN_VREF_PIS ) {
    name="VREF_PIS"; 
  } 
  if( fncd == TFN_VWAI_PIS ) {
    name="VWAI_PIS"; 
  } 
  if( fncd == TFN_VPREQ_PIS ) {
    name="VPREQ_PIS"; 
  } 
  if( fncd == TFN_VTWAI_PIS ) {
    name="VTWAI_PIS"; 
  } 
  if( fncd == TFN_VSIG_PIS ) {
    name="VSIG_PIS"; 
  } 
  if( fncd == TFN_VSET_TSP ) {
    name="VSET_TSP"; 
  } 
  if( fncd == TFN_VGET_TSP ) {
    name="VGET_TSP"; 
  } 
  if( fncd == TFN_VSET_CPR ) {
    name="VSET_CPR"; 
  } 
  if( fncd == TFN_VGET_CPR ) {
    name="VGET_CPR"; 
  } 


  /* ꤵʤä */
  if( name == NULL) {
    name="NOSUPPORT";
  }

  return name;

}

#ifdef __cplusplus
}
#endif
