/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: JtiDataInputStream.cc
   Note: JtiDataInputStream饹Υͥƥ֥᥽åɷ

   Version
    0.020     1999/10/1  λ()꡼С
    0.030     1999/10/
*/

#include <jni.h>

/* JAVAHǺincludeե */
#ifdef JTRON_JAVAH
#include <jp_gr_itron_jtron_stream_JtiDataInputStream.h>
#endif
#ifndef JTRON_JAVAH
#include <system_pkgs/jp_gr_itron_jtron_stream_JtiDataInputStream.h>
#endif

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JTRON饹 */
#include <jti_common.h>
#ifndef LINUXDEV
#include <jti_stream_common.h>
#endif

/* Linuxƥ */
#ifdef LINUXDEV
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <streamstub.h>
#endif

/*  */
#ifndef LINUXDEV
/* #include <bstdio.h> */
#include <bstdlib.h>
#include <bstring.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

JNIEXPORT jint JNICALL Java_jp_gr_itron_jtron_stream_JtiDataInputStream_jtidatastreamread
(JNIEnv *env, jobject thisObj, jbyteArray jba, jint offset, jint len, jint tmout)
{
  int er;
  jbyte *b;
  char *c;
  int i;

  jclass clazz;
  jfieldID fid;
  int stmid;
  
  int startP;

  /* ȥ꡼IDμ */
  clazz = env->GetObjectClass(thisObj);
  fid = env->GetFieldID(clazz,"streamId","I");
  stmid = env->GetIntField(thisObj,fid);

#ifdef JTRON_DEBUG
  printf("> call jtidatastreamread() stmid=%d tmout=%d\n",stmid,tmout);
/*
  printf("> stmid=%d\n",stmid);
  printf("> offset=%d\n",offset);
  printf("> len=%d\n",len);
  printf("> tmout=%d\n",tmout);
*/
#endif

  /* ѥ᡼ϤƤJavaCˤ롣 */
  jsize alen = env->GetArrayLength(jba);
  jbyte *array = env->GetByteArrayElements(jba,0);

#ifdef JTRON_DEBUG
/*
  printf("> alen=%d\n",alen);
*/
#endif

  /* offsetͤꤵ줿ν */
  if( offset > 0) {
    startP=offset;
  } else {
    startP=0;
  }

#ifdef JTRON_DEBUG
/*
  printf("> startP=%d\n",startP);
*/
  printf("> Call jti_java_stm_rea\n");
#endif

  // ɤ߹ߥ᥽åɤμ¹
  er = jti_java_stm_rea(stmid,&array[startP],len,tmout);

#ifdef JTRON_DEBUG
  c=(char *)&array[startP];
  printf("> Call Return jti_java_stm_rea:er=%d data=%c\n",er,c[0]);
/*
  if(er >= 0 ) {
    c=(char *)&array[startP];
    for(i=0;i<len;i++) {
      printf("> jtidatastreamread(a):c[%d]=%c\n",i,c[i]);
    }
  }
*/
#endif


  // Java֤
  env->ReleaseByteArrayElements(jba,array,0);

  return er;

}

#ifdef __cplusplus
}
#endif

