/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: jti_stream_common.cc
   Note: ȥ꡼९饹̥롼

   Version
    0.020     1999/10/1  λ()꡼С
    0.030     1999/10/
*/

/* ITRON  */
#ifdef LINUXDEV
#include <itron.h>
#include <ifncode.h>
#include <ierrno.h>
#endif

/* JTRON饹 */
#include <jti_common.h>
#ifndef LINUXDEV
#include <jti_stream_common.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif


ER jti_java_stm_open(int stmid)
{
  UW par[4];
  ER er;

#ifdef JTRON_DEBUG
  printf("? jti_java_stm_open stmid=%d\n",stmid);
#endif

  par[0]=stmid;

  er = jti_java_if(J_STM_OPN, par);

  return er;
}

ER jti_java_stm_outclose(int stmid)
{
  UW par[4];
  ER er;

#ifdef JTRON_DEBUG
  printf("? jti_java_stm_outclose stmid=%d\n",stmid);
#endif

  par[0]=stmid;

  er = jti_java_if(J_STM_O_CLS, par);

  return er;

}

ER jti_java_stm_inclose(int stmid)
{
  UW par[4];
  ER er;

#ifdef JTRON_DEBUG
  printf("?  jti_java_stm_inclose stmid=%d\n",stmid);
#endif

  par[0]=stmid;

  er = jti_java_if(J_STM_I_CLS, par);

  return er;
}

ER jti_java_stm_wri(int stmid,VP dp,int len,int tmo)
{
  UW par[4];
  ER er;

#ifdef JTRON_DEBUG
  printf("? jti_java_stm_wri stmid=%d len=%d tmout=%d\n",stmid,len,tmo);
#endif

  par[0]=stmid;
  par[1]=(UW)dp;
  par[2]=len;
  par[3]=tmo;

  er = jti_java_if(J_STM_O_WRI, par);

  return er;
}

ER jti_java_stm_rea(int stmid,VP dp,int len,int tmo) 
{
  UW par[4];
  ER er;

#ifdef JTRON_DEBUG
  printf("? jti_java_stm_rea stmid=%d len=%d tmout=%d\n",stmid,len,tmo);
#endif

  par[0]=stmid;
  par[1]=(UW)dp;
  par[2]=len;
  par[3]=tmo;

  er = jti_java_if(J_STM_I_REA, par);

  return er;

}

#ifdef __cplusplus
}
#endif
