/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
	jstream.c	JTRON 2.0 ITRON ĥ I/F ޥ͡
			ȥ꡼
*/
#include	<basic.h>
#include	<inner.h>
#include	<bstring.h>
#include	<bstdio.h>
#include	<bsys/util.h>
#include	<kernel/util.h>
#include	"if_jt2ext.h"

#define	MIN_STMID	(1)		/* Ǿȥ꡼ ID		*/
#define	MAX_STMID	(10)		/* 祹ȥ꡼ ID		*/

/*
	󥰥Хåե¤
*/
typedef	struct {
	VP	bufptr;			/* Хåեݥ		*/
	W	bufsz;			/* Хåե		*/
	UW	rpos;			/* Хåեɤ߹߰ 	*/
	UW	wpos;			/* Хåե񤭹߰ 	*/
	ID	rtsk;			/* ɤ߹Ԥ ID	*/
	ID	wtsk;			/* 񤭹Ԥ ID	*/
	UB	stat;			/* Хåե			*/
	UB	alloc;			/* Хåեե饰	*/
} R_BUF;

/* Хåե񤭹߲ǽ */
#define	WRISZ(p)	((p)->rpos + (p)->bufsz - (p)->wpos)

/* Хåեɤ߹߲ǽ */
#define	REASZ(p)	((p)->wpos - (p)->rpos)

/* Хåե : ξǾ֤ΤȤ̤³֤Ȥߤʤ */
#define	S_DISCON	0x00		/* Ǿ (̤³)	*/
#define	S_CON		0x01		/* ³			*/
#define	S_FINSND	0x02		/* λ			*/
#define	S_FDISCON	0x03		/* Ǿ			*/

/*
	ȥ꡼๽¤
*/
typedef	struct {
	VP	exinf;			/* ĥ			*/
	ATR	atr;			/* °				*/
	R_BUF	rcv;			/* Хåե			*/
	R_BUF	snd;			/* Хåե			*/
} STMCB;

LOCAL	STMCB		stream[MAX_STMID + 1];

LOCAL	FastLock	stm_lock;	/* ꡼¾å	*/

/*
	ԤνΤ˥٥ȤѤ
		 ¿ŤԤϤʤᡢ̤ʥ꥽ɬפȤʤ
		   ٥ȤѤ뤳Ȥˤ
*/
#define	STM_EVT		(8)		/* Ԥѥ٥		*/

/*
	ȥ꡼Ԥ
*/
LOCAL	ER	sleep_stm(ID *idp, TMO tmout)
{
	ER	er;

	get_tid(idp);
	Unlock(&stm_lock);
	er = vwai_tev(1 << (STM_EVT - 1), tmout);
	Lock(&stm_lock);
	if (er >= 0 && *idp == 0) er = E_DLT;
	*idp = 0;
	return er;
}
/*
	ȥ꡼Ԥ
*/
LOCAL	VOID	wakeup_stm(ID tid)
{
	if (tid > 0) vset_tev(tid, STM_EVT);
}
/*
	󥰥Хåեؤν񤭹
*/
LOCAL	W	write_buf(R_BUF *p, VP data, W len, TMO tmout)
{
	ER	er;
	W	sz, ofs;

	/* ¿Ԥϥ顼 */
	if (p->wtsk > 0) return E_OBJ;

	/* ³֡Ľ񤭹߲ǽ > 0 ˤʤޤԤ */
	while (p->stat != S_CON || (sz = WRISZ(p)) <= 0) {
		/* Ǿ֤ΤȤϡǾ֤˰ܹԤ E_CLS ᤹ */
		if (p->stat == S_FDISCON) {
			p->stat = S_DISCON;
			p->wpos = p->rpos = 0;	/* ˤ */
			return E_CLS;
		}
		er = sleep_stm(&p->wtsk, tmout);
		if (er < E_OK) return er;
	}

	/* Хåեؤν񤭹 */
	ofs = p->wpos % p->bufsz;
	if (len > sz) len = sz;
	if ((sz = p->bufsz - ofs) > len) sz = len;
	memcpy(p->bufptr + ofs, data, sz);
	if (len > sz) memcpy(p->bufptr, data + sz, len - sz);
	p->wpos += len;

	/* ɤ߹ԤԤ */
	wakeup_stm(p->rtsk);
	return len;
}
/*
	󥰥Хåեɤ߹
*/
LOCAL	W	read_buf(R_BUF *p, VP data, W len, TMO tmout)
{
	ER	er;
	W	sz, ofs;

	/* ¿Ԥϥ顼 */
	if (p->rtsk > 0) return E_OBJ;

	if (p->bufsz == 0) {	/* Ʊȥ꡼ */
		/* Хåե */
		p->bufptr = data;
		p->bufsz = len;
		p->rpos = p->wpos = 0;

		/* 񤭹ԤԤ */
		wakeup_stm(p->wtsk);

		/* Хåեؤν񤭹Ԥ */
		er = E_OK;
		while ((len = p->wpos) <= 0) {
			/* λ֤ΤȤϡǾ֤˰ܹԤ 0 ᤹ */
			if (p->stat == S_FINSND) {
				p->stat = S_DISCON;
				er = E_OK;
				len = 0;
				break;
			}
			er = sleep_stm(&p->rtsk, tmout);
			if (er < E_OK) break;
		}
		/* Хåե */
		p->bufptr = NADR;
		p->bufsz = 0;
		p->rpos = p->wpos = 0;
		if (er < E_OK) return er;

	} else {		/* Ʊȥ꡼ */
		/* ɤ߹߲ǽ > 0 ˤʤޤԤ */
		while ((sz = REASZ(p)) <= 0) {
			/* λ֤ΤȤϡǾ֤˰ܹԤ 0 ᤹ */
			if (p->stat == S_FINSND) {
				p->stat = S_DISCON;
				p->wpos = p->rpos = 0;	/* ˤ */
				return 0;
			}
			er = sleep_stm(&p->rtsk, tmout);
			if (er < E_OK) return er;
		}

		/* Хåեɤ߹ */
		ofs = p->rpos % p->bufsz;
		if (len > sz) len = sz;
		if ((sz = p->bufsz - ofs) > len) sz = len;
		memcpy(data, p->bufptr + ofs, sz);
		if (len > sz) memcpy(data + sz, p->bufptr, len - sz);
		p->rpos += len;

		/* 񤭹ԤԤ */
		wakeup_stm(p->wtsk);
	}
	return len;
}
/*
	Хåեγ
*/
LOCAL	ER	alloc_buf(R_BUF *p)
{
	ER	er = E_OK;

	p->alloc = 0;
	if (p->bufptr == NADR && p->bufsz > 0) {
		p->bufptr = Kmalloc(p->bufsz);
		if (p->bufptr != NULL) {
			p->alloc = 1;
		} else {
			p->bufptr = NADR;
			er = E_NOMEM;
		}
	}
	return er;
}
/*
	Хåեβ
*/
LOCAL	VOID	free_buf(R_BUF *p)
{
	if (p->alloc != 0 && p->bufptr != NADR) {
		Kfree(p->bufptr);
		p->bufptr = NADR;
		p->alloc = 0;
	}
}
/*
	ȥ꡼
		E_ID, E_PAR, E_RSATR, E_OBJ
*/
EXPORT	ER	_jti_cre_stm(ID stmid, T_JTI_CSTM *pk_cstm)
{
	ER	er;
	STMCB	*s;
	ATR	atr;

	if (stmid < MIN_STMID || stmid > MAX_STMID) return E_ID;
	if (pk_cstm == NULL || pk_cstm == NADR) return E_PAR;
	atr = pk_cstm->stmattr;
	if ((atr & (TA_READ | TA_WRITE)) == 0) return E_PAR;
	if ((atr & ~(TA_READ | TA_WRITE)) != 0) return E_RSATR;
	if ((atr & TA_READ) != 0) {
		if (pk_cstm->rbufsz < 0 || pk_cstm->rbuf == NULL) return E_PAR;
	}
	if ((atr & TA_WRITE) != 0) {
		if (pk_cstm->wbufsz < 0 || pk_cstm->wbuf == NULL) return E_PAR;
	}

	Lock(&stm_lock);

	s = &stream[stmid];
	if (s->atr != 0) {er = E_OBJ; goto EEXIT;}

	if ((atr & TA_READ) != 0) {
		s->rcv.bufsz = pk_cstm->rbufsz;
		s->rcv.bufptr = pk_cstm->rbuf;
		er = alloc_buf(&s->rcv);
		if (er < E_OK) goto EEXIT;
	}
	if ((atr & TA_WRITE) != 0) {
		s->snd.bufsz = pk_cstm->wbufsz;
		s->snd.bufptr = pk_cstm->wbuf;
		er = alloc_buf(&s->snd);
		if (er < E_OK) goto EEXIT;
	}
	s->exinf = pk_cstm->exinf;
	s->atr = atr;
	er = E_OK;
EEXIT:
	Unlock(&stm_lock);

	return er;
}
/*
	ȥ꡼κ
		E_ID, E_NOEXS, E_OBJ
*/
EXPORT	ER	_jti_del_stm(ID stmid)
{
	ER	er;
	STMCB	*s;

	if (stmid < MIN_STMID || stmid > MAX_STMID) return E_ID;

	Lock(&stm_lock);

	s = &stream[stmid];
	if (s->atr == 0) {
		er = E_NOEXS;
	} else if (s->snd.stat != S_DISCON || s->rcv.stat != S_DISCON) {
		er = E_OBJ;
	} else {
		wakeup_stm(s->snd.rtsk);
		wakeup_stm(s->snd.wtsk);
		wakeup_stm(s->rcv.rtsk);
		wakeup_stm(s->rcv.wtsk);
		free_buf(&s->snd);
		free_buf(&s->rcv);
		memset(s, 0, sizeof(STMCB));
		er = E_OK;
	}
	Unlock(&stm_lock);

	return er;
}
/*
	ȥ꡼ؤ
		E_ID, E_NOEXS, E_PAR, E_OBJ, E_TMOUT, E_RLWAI, E_CLS
*/
EXPORT	ER	_jti_wri_stm(ID stmid, VP data, INT len, TMO tmout)
{
	ER	er;
	STMCB	*s;

	if (stmid < MIN_STMID || stmid > MAX_STMID) return E_ID;
	if (data == NULL || data == NADR || len <= 0 || tmout < TMO_FEVR)
				return E_PAR;

	Lock(&stm_lock);

	s = &stream[stmid];
	if ((s->atr & TA_WRITE) == 0) {
		er = (s->atr == 0) ? E_NOEXS : E_OBJ;
	} else {
		/* Хåեؤν񤭹 */
		er = write_buf(&s->snd, data, len, tmout);
	}

	Unlock(&stm_lock);

	return er;
}
/*
	ȥ꡼फμ
		E_ID, E_NOEXS, E_PAR, E_OBJ, E_TMOUT, E_RLWAI, E_CLS
*/
EXPORT	ER	_jti_rea_stm(ID stmid, VP data, INT len, TMO tmout)
{
	ER	er;
	STMCB	*s;

	if (stmid < MIN_STMID || stmid > MAX_STMID) return E_ID;
	if (data == NULL || data == NADR || len <= 0 || tmout < TMO_FEVR)
				return E_PAR;

	Lock(&stm_lock);

	s = &stream[stmid];
	if ((s->atr & TA_READ) == 0) {
		er = (s->atr == 0) ? E_NOEXS : E_OBJ;
	} else {
		/* Хåեɤ߹ */
		er = read_buf(&s->rcv, data, len, tmout);
	}
	Unlock(&stm_lock);

	return er;
}
/*
	ȥ꡼ؤνλ
		E_ID, E_NOEXS, E_OBJ, E_CLS
*/
EXPORT	ER	_jti_sht_stm(ID stmid)
{
	ER	er;
	STMCB	*s;

	if (stmid < MIN_STMID || stmid > MAX_STMID) return E_ID;

	Lock(&stm_lock);

	s = &stream[stmid];
	if ((s->atr & TA_WRITE) == 0) {
		er = (s->atr == 0) ? E_NOEXS : E_OBJ;
	} else {
		if (s->snd.wtsk > 0) {
			er = E_OBJ;
		} else if (s->snd.stat == S_CON) {
			s->snd.stat = S_FINSND;
			er = E_OK;
		} else if (s->snd.stat == S_FDISCON) {
			s->snd.stat = S_DISCON;
			s->snd.wpos = s->snd.rpos = 0;	/* ˤ */
			er = E_CLS;
		} else {
			er = E_OBJ;
		}
	}
	Unlock(&stm_lock);
	return er;
}
/*
	ȥ꡼ؤξֻ
		E_ID, E_PAR, E_NOEXS
*/
EXPORT	ER	_jti_ref_stm(ID stmid, T_JTI_RSTM *pk_rstm)
{
	ER	er;
	STMCB	*s;

	if (stmid < MIN_STMID || stmid > MAX_STMID) return E_ID;
	if (pk_rstm == NULL || pk_rstm == NADR) return E_PAR;

	Lock(&stm_lock);

	s = &stream[stmid];
	if (s->atr == 0) {
		er = E_NOEXS;
	} else {
		pk_rstm->wrisz = ((s->atr & TA_WRITE) == 0) ?
					-1 : WRISZ(&s->snd);
		pk_rstm->reasz = ((s->atr & TA_READ) == 0) ?
					-1 : REASZ(&s->rcv);
		pk_rstm->exinf = s->exinf;
		er = E_OK;
	}
	Unlock(&stm_lock);

	return er;
}
/*
	ƥ JAVA I/F
*/
EXPORT	ER	_jti_java_stm(INT cmd, VP par)
{
	ER	er;
	ID	stmid;
	STMCB	*s;

	stmid = ((W*)par)[0];
	if (stmid < MIN_STMID || stmid > MAX_STMID) return E_ID;

	Lock(&stm_lock);

	s = &stream[stmid];
	if (s->atr == 0) {er = E_NOEXS; goto EEXIT;}

	switch(cmd) {
	case 0:		/* Open		*/
		if (s->rcv.stat != S_DISCON || s->snd.stat != S_DISCON) {
			er = E_OBJ;
		} else {
			if (s->atr & TA_READ)  s->rcv.stat = S_CON;
			if (s->atr & TA_WRITE) s->snd.stat = S_CON;
			wakeup_stm(s->snd.wtsk);
			er = E_OK;
		}
		break;
	case 1:		/* Output.Close	*/
		if (s->rcv.stat == S_CON) {
			s->rcv.stat = S_FINSND;
			wakeup_stm(s->rcv.rtsk);
			er = E_OK;
		} else {
			er = E_OBJ;
		}
		break;
	case 2:		/* Input.Close	*/
		if (s->snd.stat == S_CON) {
			s->snd.stat = S_FDISCON;
			wakeup_stm(s->snd.wtsk);
			er = E_OK;
		} else if (s->snd.stat == S_FINSND) {
			s->snd.stat = S_DISCON;
			s->snd.rpos = s->snd.wpos = 0;	/* ˤ */
			er = E_OK;
		} else {
			er = E_OBJ;
		}
		break;
	case 3: 	/* Output.Write	*/
	    {	VP	dp = (VP)(((W*)par)[1]);
		INT	len = (INT)(((W*)par)[2]);
		TMO	tmo = (TMO)(((W*)par)[3]);

		if (dp == NULL || dp == NADR || len <= 0 || tmo < TMO_FEVR) {
			er = E_PAR;
		} else if (s->rcv.stat == S_CON) {
			/* Хåեؤν񤭹 */
			er = write_buf(&s->rcv, dp, len, tmo);
		} else {
			er = E_OBJ;
		}
		break;
	    }
	case 4:		/* Input.Read	*/
	    {	VP	dp = (VP)(((W*)par)[1]);
		INT	len = (INT)(((W*)par)[2]);
		TMO	tmo = (TMO)(((W*)par)[3]);

		if (dp == NULL || dp == NADR || len <= 0 || tmo < TMO_FEVR) {
			er = E_PAR;
		} else if (s->snd.stat == S_CON || s->snd.stat == S_FINSND) {
			/* Хåեɤ߹ */
			er = read_buf(&s->snd, dp, len, tmo);
			if (er == 0) er = -1;
		} else {
			er = E_OBJ;
		}
		break;
	    }
	default:	er = E_RSFN;
	}

EEXIT:
	Unlock(&stm_lock);

	return er;
}
/*
	ȥ꡼ν / λ
*/
EXPORT	ER	init_stream(Bool StartUp)
{
	if (StartUp == True) {	/*  */
		memset(&stream[0], 0, sizeof(stream));

		/* ®å */
		CreateLockWN(&stm_lock, "jstm");
	} else {		/* λ */
		/* ®åκ */
		DeleteLock(&stm_lock);
	}
	return E_OK;
}
