/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: jti_shared.h
   Note: JTRON 2.0 ITRON API
         ֥ͭȥ󥿡եإåե
   Date: 1999/8/16
   Last update: 1999/11/30
*/
#ifndef _JTI_SHARED_H_
#define _JTI_SHARED_H_

#ifndef JNI_H
#include <jni.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* ǡ  */
#ifndef _I_JT2EXT_H_
typedef INT  JNO ;
#endif
typedef INT  ER_BOOL ;
#ifndef _ITRON_
typedef INT  ER ;
#endif

/****************************
  ֥ͭȥ
****************************/

#define JTI_MBX_ID_SHOBJ   3    /* ̿ѥᥤܥåID (ͽ) */
#define JTI_MAX_SO_NAME    63    /* ֥ͭ̾κĹ */

/*
   ֥ͭȴơ֥
*/
typedef struct sho_tbl {
  JNO  sho_id ;              /* Shared object ID (Semapho ID)*/
  char name[JTI_MAX_SO_NAME+1] ; /* Shared object name */
  INT  lock_stat ;    /* Lock status */
  ID   lock_owner ;   /* Lock owner (Task ID) */
  JNIEnv  *jni_env ;  /* JNI interface pointer */
  jobject  jni_obj ;  /* JNI shared object */
  struct sho_tbl *next ;   /* Pointer to next table */
} SHO_TBL ;

/*
   ֥ͭȤؤΥݥ : jti_get_mem()
*/
typedef struct jni_ptr {
  JNIEnv  *env ;  /* JNI interface pointer */
  jobject  obj ;  /* JNI shared object */  
} JNI_PTR ;

/* åơlock_stat */
#define UNLOCK        0    /* å */
#define LOCK_TASK     1    /* ˤå */
#define LOCK_THREAD   2    /* åɤˤå */

/*
   åХåե
*/
typedef struct msg_sho {
  T_MSG	     pk_msg ;   /* Mail-box message header */
  SHO_TBL  **solist ;   /* ֥ͭȴơ֥ꥹȡƬ */
} MSG_SHO ;

/***************************************
   Javaåɡåɥ롼
***************************************/
#define JTI_MBX_ID_THREAD      2    /* ̿ѥᥤܥåID (ͽ) */
#define JTI_MAX_THREAD_NAME   31    /* åɡåɥ롼̾κĹ */

/*
   åХåե
*/
/* jti_get_thr,jti_get_tgr  */
typedef struct msg_send_name {
  T_MSG	pk_msg ;   /* Mail-box message header */
  INT	kind ;     /* Sort of API */
  INT	len ;      /* Thread/ThreadGroup name length */
  char	name[JTI_MAX_THREAD_NAME+1] ; /* Thread/ThreadGroup name */
} MSG_SEND_NAME ;

/* ¾API */
typedef struct msg_send {
  T_MSG	pk_msg ; /* Mail-box message header */
  INT	kind ;   /* Sort of API */
  JNO	id ;     /* Thread/ThreadGroup ID */
  INT	jpri ;   /* Java priority */
} MSG_SEND ;

/*
   åХåե
*/
typedef struct msg_recv {
  T_MSG	pk_msg ; /* Mail-box message header */
  INT	ercd ;   /* Error cord */
  INT	jpri ;   /* 'Java priority' or 'thread/thread-group ID' */
} MSG_RECV ;

/************************/
/* ITRON API ǽ */
/************************/

/* Javaåɡꥢ륿ॿΥޥåԥ */
#define IA_SET_HPR       1   /* jti_set_hpr */
#define IA_GET_HPR       2   /* jti_get_hpr */
#define IA_GET_LPR       3   /* jti_get_lpr */

/* ֥ͭȥ */
#define IA_SHO_GET_ID   11    /* Get shared object ID */
#define IA_SHO_GET_MEM  12    /* Get address of shared object */
#define IA_SHO_LOC      13    /* Lock shared object */
#define IA_SHO_UNL      14    /* Unlock shared object */
#define IA_SHO_FUNL     15    /* ForceUnlock shared object */

/* Javaå */
#define IA_THR_GET_ID   20   /* Get thread ID */
#define IA_THR_ISA      21   /* isAlive */ 
#define IA_THR_INT      22   /* interrupt */
#define IA_THR_ISI      23   /* isInterrupted */
#define IA_THR_SUS      24   /* suspend */
#define IA_THR_RSM      25   /* resume */
#define IA_THR_STA      26   /* start */
#define IA_THR_STP      27   /* stop */
#define IA_THR_GET_JPR  28   /* getPriority */
#define IA_THR_SET_JPR  29   /* setPriority */
#define IA_THR_DES      30   /* destroy */

/* Javaåɥ롼 */
#define IA_TGR_GET_ID   31   /* Get thread-group ID */
#define IA_TGR_DES      32   /* destroy */
#define IA_TGR_SUS      33   /* suspend */
#define IA_TGR_RSM      34   /* resume */
#define IA_TGR_STP      35   /* stop */

/*****
  100 -> reserved
*****/

#ifdef __cplusplus
}
#endif
#endif  /* _JTI_SHARED_H_ */
